/* $Id: file.c,v 1.1 1995/03/30 06:28:09 jt Exp $ */
/* file.c */
/* Ts/tools routines for opening and closing files */

#include	<stdio.h>

#define EMPTYSTRING(str) ((str)==NULL || *(str)=='\0')

/* openfile:
 *     open a file for reading or writing
 *     if filename is empty, then return fp = fpDefault
 *     if filename is "-", then return fp=stdin/stdout
 *                 depending on whether rw is read/write
 *     if filename exists, then open that file
 *     if filename can't be opened, write error to stderr
 */

FILE *openFile(s,rw,fpDefault)
char *s;          /* filename */
char *rw;         /* read or write */
FILE *fpDefault;  /* default if filename is blank */
{
	FILE *fp;
	if (EMPTYSTRING(s))
		fp = fpDefault;
	else {
		if (s[0]=='-' && s[1]=='\0') {
			switch (rw[0]) {
			case 'r': fp = stdin; break;
			case 'w': fp = stdout; break; 
			default:
				fp=NULL;
				fprintf(stderr,"Invalid rw argument to openFile(.,%s,.)",rw);
				break;
			}
		} else {
			fp = fopen(s,rw);
			if(fp == NULL) 
				fprintf(stderr,"openFile: Unable to open file %s.\n",s);
		}
	}
	return fp;
}
closeFile(fp)
FILE *fp;
{
	if (fp != NULL && fp != stdin && fp != stdout && fp != stderr)
		fclose(fp);
}
