#define PACKAGE "opt"
#define VERSION "3.7"
#include "opt.h"
/* OPT v3.7: options parsing tool */
/*
 * Copyright (C) 1998, James Theiler (jt@lanl.gov)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 * 
 */
/*
    Copyright (C) 1996,1997 James Theiler 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    You can find the latest version of OPT on the web
    http://nis-www.lanl.gov/~jt/Software
    Or you can email the author: jt@lanl.gov

*/
/* $Id: opt.c,v 1.1 1998/09/19 04:10:07 jt Exp $ */
#define SINGLEFILE 1

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#ifdef convex
#include <strings.h>
#else
#include <string.h>
#endif

#ifdef __TURBOC__
#include <alloc.h>
#endif


/** You may want to edit the #define's below **/

#ifndef HAVE_STRDUP
#define HAVE_STRDUP 1
#endif

#ifndef HAVE_UNISTD_H
#define HAVE_UNISTD_H 0
#endif

#ifndef HAVE_LONGJMP
#define HAVE_LONGJMP 0
#endif

#ifndef HAVE_SIGNAL
#define HAVE_SIGNAL 0
#endif

#ifndef RETSIGTYPE
#define RETSIGTYPE void
#endif

/** end opt_sf.h **/

/* OPT v3.7: options parsing tool */
/*
 * Copyright (C) 1998, James Theiler (jt@lanl.gov)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 * 
 */
/* $Id: opt.c,v 1.1 1998/09/19 04:10:07 jt Exp $ */
/* ag.h */


#ifndef _AG_H
#define _AG_H

#ifndef	TRUE
#define	TRUE	1
#define	FALSE	0
#endif

/*************************************
 * ARGVECTOR structure
 * Basically, an (argc,argv) construct
 * with indices to which character of 
 * which word is the current position
 */

typedef struct {
    char    **v;            /* argument vector */
    int     c;              /* argument count  */
    int     iw;             /* current word    */
    int     ic;             /* current character */
}   ARGVECTOR;

/* 
 * Function prototypes 
 */


extern  ARGVECTOR *ag_new(int,char **);
extern  void       ag_free(ARGVECTOR *);
extern  void       ag_fprint(FILE *, ARGVECTOR *);
extern  int        ag_enstring(char *,ARGVECTOR *,int);
extern  void       ag_reset(ARGVECTOR *);
extern  int        ag_w_number(ARGVECTOR *);
extern  void       ag_w_advance(ARGVECTOR *);
extern  int        ag_eow(ARGVECTOR *);
extern  int        ag_end(ARGVECTOR *);
extern  char       ag_c(ARGVECTOR *);
extern  char       ag_c_next(ARGVECTOR *);
extern  char       ag_cnn_next(ARGVECTOR *);
extern  char       ag_c_advance(ARGVECTOR *);
extern  char       ag_backspace(ARGVECTOR *);
extern  void       ag_backword(ARGVECTOR *);
extern  char      *ag_s(ARGVECTOR *);
extern  char      *ag_s_next(ARGVECTOR *);
extern  char      *ag_s_advance(ARGVECTOR *);
extern  int        ag_clear(ARGVECTOR *);
extern  int        ag_argc(ARGVECTOR *);
extern  char     **ag_argv(ARGVECTOR *);
extern  ARGVECTOR *ag_copy(ARGVECTOR *);
extern  void       ag_freeall(ARGVECTOR *);
extern  ARGVECTOR *ag_prepend_argv0(ARGVECTOR *, char *);
extern  char      *argnext(ARGVECTOR *);
extern  double     argnextnum(ARGVECTOR *);


#endif /* _AG_H */








/* OPT v3.7: options parsing tool */
/*
 * Copyright (C) 1998, James Theiler (jt@lanl.gov)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 * 
 */
/* $Id: opt.c,v 1.1 1998/09/19 04:10:07 jt Exp $ */
/* opt_p.h */
/*
 *	Private header file for OPT package.
 */

#ifndef _OPT_P_H
#define _OPT_P_H

#ifndef	OPT_TRUE
#define	OPT_TRUE	1
#define	OPT_FALSE	0
#endif

#ifndef DEBUG
#define DEBUG 0
#endif

typedef enum { False=OPT_FALSE, True=OPT_TRUE } flag;

/* 
 * These are delimiter characters 
 */
#define DELIM		'-'		/* option delimiter character */
#define	ALTDELIM	'/'		/* alternate delimiter character */
#define	OPTFROMFILE	'@'		/* denotes options are in a file */
#define	OPTTOFILE	'%'		/* says to put options in a file */
#define	DOCUMENT	'-'		/* write document to file */
#define	INTERACT	'$'		/* Flags interactive menu */
#define	HELPCH		'?'		/* Help character */
/*
 * These are not available on command line 
 * But may be invoked from a file
 */
#define IGNOREEOL       ';'		/* Ignore until the end of line */
#define	RUN             '='		/* Says to just run to completion */
#define	QUITCH		'.'		/* Quit character */
/*
 * These are not available on command line or from a file
 * But may be invoked from the menu
 */
#define	BANG		'!'		/* Shell escape character */
#define	ADDITIONAL_OPTS	'+'		/* Additional options */

#define ISEMPTYSTRING(s) (!((s) && *(s)))

/******************
 * Global variables
 */
extern	int	opt_nreg;
extern	flag	menuflag;
extern	flag	fileflag;
extern  int     opt_exit_number;
/*********************
 * Function Prototypes
 */

extern	void	opt_get_help(char);
extern  char   *optgetTitle(void);
extern  int     opt_char_number(char);

extern  int	opt_fprint(FILE *,int);
extern  void	opt_tofile(FILE *);
extern	char	*optstrval(int);
extern	char	*optstrtyp(int);
extern  int     opt_undelim(ARGVECTOR *);
extern  int     opt_delim(ARGVECTOR *);
extern  int     opt_longdelim(ARGVECTOR *);

extern void short_usage(void);
extern void long_usage(void);


		/* --------------- */
		/* Process Options */
		/* --------------- */

extern	char	  *opt_program_name;
extern  OPT_PFI    opt_additional_usage_fcn;
extern  OPT_PFI    opt_quit_fcn, opt_help_fcn, opt_run_fcn;

extern	void       opt_wr_title(void);
extern  int        opt_fromfname(char *);
extern	int	   opt_tofname(char *);
extern  int        opt_getline(char *,FILE *);
extern	char	  *opt_mstring(int);
extern  ARGVECTOR *opt_process(int,char **);
extern  char      *short_progname(char *);
extern  int        opt_undelim(ARGVECTOR *);
extern  int        opt_delim(ARGVECTOR *);
extern  int        opt_lineprocess(char *);
extern	void	   opt_menu(void);
extern  void       opt_menu_getresponse(char *, char *, int);

extern	void	opt_help(char *);
extern	void	opt_quit(void);
extern	void	opt_usage(void);
extern  void    opt_readline_init(char *);  

#define opt_warn_1(fmt,var1) do { \
    char gstr[180]; sprintf(gstr,fmt,var1); \
        opt_warning(gstr); } while(0)
#define opt_warn_2(fmt,var1,var2) do { \
    char gstr[180]; sprintf(gstr,fmt,var1,var2); \
	opt_warning(gstr); } while(0)
#define opt_warn_3(fmt,var1,var2,var3) do { \
    char gstr[180]; sprintf(gstr,fmt,var1,var2,var3); \
	opt_warning(gstr); } while(0)

#define opt_mess_1(fmt,var1) do { \
    char gstr[180]; sprintf(gstr,fmt,var1); \
	opt_message(gstr); } while(0)
#define opt_mess_2(fmt,var1,var2) do { \
    char gstr[180]; sprintf(gstr,fmt,var1,var2); \
	opt_message(gstr); } while(0)
#define opt_mess_3(fmt,var1,var2,var3) do { \
    char gstr[180]; sprintf(gstr,fmt,var1,var2,var3); \
	opt_message(gstr); } while(0)
#define opt_mess_4(fmt,var1,var2,var3,var4) do { \
    char gstr[180]; sprintf(gstr,fmt,var1,var2,var3,var4); \
	opt_message(gstr); } while(0)

#define opt_fatal_1(fmt,var1) do { \
    char gstr[180]; sprintf(gstr,fmt,var1); \
	opt_fatal(gstr); } while(0)
#define opt_fatal_2(fmt,var1,var2) do { \
    char gstr[180]; sprintf(gstr,fmt,var1,var2); \
	opt_fatal(gstr); } while(0)
#define opt_fatal_3(fmt,var1,var2,var3) do { \
    char gstr[180]; sprintf(gstr,fmt,var1,var2,var3); \
	opt_fatal(gstr); } while(0)


#ifndef HAVE_STRDUP
#define HAVE_STRDUP 0
#endif

#if !HAVE_STRDUP
char *strdup(char *s);
#endif

#endif /* _OPT_P_H */
/* OPT v3.7: options parsing tool */
/*
 * Copyright (C) 1998, James Theiler (jt@lanl.gov)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 * 
 */
/* $Id: opt.c,v 1.1 1998/09/19 04:10:07 jt Exp $ */
/**************************
 *  some useful utilities *
 **************************/
/*
 *  *** NO LONGER AVAILABLE!!
 *  *** 1) Variable argument lists: for error messages
 *  ***   opt_errmess(), gives message and then aborts run
 *     
 *  2) Long Jump: for aborting run() without losing the entire job
 *     optBeginRun()
 *     optAbortRun()
 *     2a) Signal: trapping ^C so that it aborts run()
 *  4) Readline: interface to GNU readline
 *     
 */
/*  Can enable longjmp with: #define HAVE_LONGJMP 1
 *  Only if longjmp is enabled can signal be enabled, using
 *                           #define HAVE_SIGNAL 1
 *  Finally, readline can be enabled with
 *                           #define HAVE_READLINE 1
 *  If this version of opt came with a configure script, then those
 *  values should be set automatically by the system at configure time.
 */
#ifndef SINGLEFILE
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#if 0                           /* Currently, config.h is not working */
#include "config.h"             /* supplies HAVE_VPRINTF + RETSIGTYPE */
#endif
#include "ag.h"
#include "opt.h"
#include "opt_p.h"
#endif /* SINGLEFILE */

/* If these are not defined on the compile command line, then assume
 * the worst, that you don't have anything!
 */
#ifndef HAVE_LONGJMP
#define HAVE_LONGJMP 0
#endif
#ifndef HAVE_SIGNAL
#define HAVE_SIGNAL 0
#endif
#ifndef RETSIGTYPE
#define RETSIGTYPE void
#endif

/* Provide message/warning/fatal functions */
/* Ordinary messages go to stdout, but warn/fatal messages to stderr;
 * (This convention adopted at suggestion of Jason V. Morgan) */
void
opt_message(char *s)
{
    if (s) fputs(s,stdout);
}
void
opt_warning(char *s)
{
    fputs("OPT Warning: ",stderr);
    if (s) fputs(s,stderr);
    fputs("\n",stderr);
}
void
opt_fatal(char *s)
{
    fputs("OPT Fatal error: ",stderr);
    if (s) fputs(s,stderr);
    exit(opt_exit_number);
}

#if HAVE_LONGJMP
#include <setjmp.h>
static jmp_buf	opt_jumpstart;
static int	opt_jump_set=FALSE;

/* prototypes */
static RETSIGTYPE set_signal(void);
static RETSIGTYPE unset_signal(void);

/**********
 * SIGNAL *
 **********/
#if HAVE_SIGNAL
#include <signal.h>

static void
catch_signal(int sig
#if 0                           /* someday make this portable! */
             ,int code, struct sigcontext *scp, char *addr
#endif                         
             )
{
    opt_message("\nOPT Interrupted:\n");
    longjmp(opt_jumpstart,1);
    perror("Did not long-jump");
    exit(0);
}

static RETSIGTYPE (*old_catcher)(int) = NULL;
static RETSIGTYPE
set_signal(void)
{
    old_catcher = signal(SIGINT,catch_signal);
}
static RETSIGTYPE
unset_signal(void)
{
    signal(SIGINT,old_catcher);
}
#else

static RETSIGTYPE   set_signal(void) {}
static RETSIGTYPE unset_signal(void) {}

#endif /* end SIGNAL */


/* optBeginRun, optAbortRun: these functions are for running
 * the run hook defined by the programmer in optRun().
 */

int
optBeginRun(OPT_PFI run)
{
    int value;

    opt_jump_set=OPT_TRUE;
    set_signal();

    value = setjmp(opt_jumpstart);
    if(value!=0)
        opt_message("OPT: Run aborted...try again\n");
    else
        value = (*run)();
	
    unset_signal();
    opt_jump_set=OPT_FALSE;

    return value;
}

void
optAbortRun(void)
{
    if(opt_jump_set)
        longjmp(opt_jumpstart,1);
    else
        /** should this be some opt_exit() ?? **/
        exit(opt_exit_number);
}

int optBeginMain(OPT_PFI_ARG run_args,int argc, char **argv)
{
    int value;

    opt_jump_set=OPT_TRUE;
    set_signal();

    value = setjmp(opt_jumpstart);
    if(value!=0)
        opt_message("OPT: Run aborted...try again\n");
    else
        value = (*run_args)(argc,argv);
	
    unset_signal();
    opt_jump_set=OPT_FALSE;

    return value;
}    

#else  /* If LONGJMP is unavailable, or disabled, then these functions
        * are rather trivial.
        */
int  optBeginRun(OPT_PFI run) { return (*run)(); }
void optAbortRun() { exit(opt_exit_number); }
int  optBeginMain(OPT_PFI_ARG run_args,int argc, char **argv)
{
    return (*run_args)(argc,argv);
}

#endif /* end LONGJMP */

void optAbortMain() { optAbortRun(); }


/************
 * Readline *
 ************/

#ifdef HAVE_READLINE
#define READLINE_LIBRARY
#include <readline/readline.h>
#include <readline/history.h>
#endif

void
opt_readline_init(char *s)
{
#ifdef HAVE_READLINE
    rl_readline_name = s;
#endif
    return;
}

void 
opt_menu_getresponse(char *prompt, char *respond, int maxlen)
{
#ifdef HAVE_READLINE
    char *line;
    line = readline(prompt);
    if (line && *line) {
	add_history(line);
	strncpy(respond,line,maxlen);
	free(line);
    } else
	respond[0] = '\0';
	/* double terminate the line */
    respond[strlen(respond)+1] = '\0';
#else
    opt_message(prompt);
    opt_getline(respond,stdin);
#endif
}

/* ...well, assume that you do have strdup, since if you do and you
 * say you don't you can get into trouble.
 */
#ifndef HAVE_STRDUP
#define HAVE_STRDUP 1
#endif

#if !HAVE_STRDUP
/* Provided here in case it is not available on system */     
char *strdup(char *s)
{
    char *sdup;
    int i,n;
    n = strlen(s);
    sdup = (char *)malloc(n+1);
    for (i=0; i<n; ++i)
        sdup[i] = s[i];
    sdup[n]='\0';
    return sdup;
}
#endif
    
/* OPT v3.7: options parsing tool */
/*
 * Copyright (C) 1998, James Theiler (jt@lanl.gov)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 * 
 */
/* $Id: opt.c,v 1.1 1998/09/19 04:10:07 jt Exp $ */
/* opt_reg.c */

/************************ register options ********************************
 *
 *    options are stored in an array,
 *    each element of which is a structure
 *
 *    The members of the structure contain information about
 *        1) the variable which is altered
 *        2) the type of variable
 *        3) a character by which the variable is invoked
 *        4) a string by which the variable can be invoked
 *        5) a brief description of the variable's role in the program
 *        6) a longer help message
 *        7) a flag indicating that an option has been invoked
 *        7) a "hook", a function that is called when variable is invoked
 *            
 *    The structure elements are not assigned directly, but are
 *    "registered" with a call to the function optreg().
 *        
 *    In this file are the routines which access the structure of
 *    registered options.
 *
 *          I) Register options 
 *         II) Get number corresponding to name of option
 *        III) Print options out
 *             a) to a file which can be used as an input command line
 *             b) to the screen as part of a usage message
 *             c) to the screen as part of an interactive menu
 *         IV) Process single delimited and undelimited options
 */

#ifndef	SINGLEFILE
#include <stdio.h>
#include <stdlib.h>
#ifdef convex
#include <strings.h>
#else
#include <string.h>
#endif
#ifdef __TURBOC__
#include <alloc.h>
#endif
#include "opt.h"
#include "ag.h"
#include "opt_p.h"
#endif

/* Default is to indicate whether a flag is true or false by using + or -
 * But, by #define'ing FLAG_ZERO_ONE, we will use 1 or 0 instead
 */
#ifdef FLAG_ZERO_ONE
#define FLAG_TRUE '1'
#define FLAG_FALSE '0'        
#else
#define FLAG_TRUE '+'
#define FLAG_FALSE '-'        
#endif

/* Prototypes for static (local) functions */
static void opt_fileheader(FILE *);
static int opt_action(int, ARGVECTOR *);
static int opt_number(void *v);
static int opt_longname_number(char *);
#if 0
static int opt_valid_longname(char *);
#endif

static char blankstringval = '\0';
#define BLANKSTRING (&blankstringval) /* non-null blank string */
#define ISVALIDNUMBER(n) ((n)>=0 && (n)<opt_nreg)

int opt_exit_number=0;          /* if we have to exit(), then exit
                                 * with this number.
                                 */

        /* -------------------------- */
        /* List of Registered Options */
        /* -------------------------- */

#define MAXOPTS 256             /* sort of an arbitrary limitation! */

typedef struct {
    void      *value;         /* pointer to value of option */
    opt_TYPE   type;          /* will be cast according to type */
    char       name;          /* name by which option is invoked */
    char      *longname;      /* long version of the name */
    char      *descript;      /* a brief description */
    char      *help;          /* longer help message */
    int        invoked;       /* flag is set to 1 if option is invoked */
    OPT_PFI    hook;          /* code to evaluate if option is invoked */
}   EACH_OPT;

static	EACH_OPT optlist[MAXOPTS];               /* array of options */
int              opt_nreg=0;                     /* number of registered opts */

    /* ---------- */
    /* OPT macros */
    /* ---------- */

#define	OPT_isflagtype(o) \
	((o)==OPT_FLAG ||    (o)==OPT_NEGFLAG || \
         (o)==OPT_ABSFLAG || (o)==OPT_ABSNEGFLAG)
#define	OPT_isundelimtype(o) ((o)==OPT_UNDELIM ||  \
                              (o)==OPT_UNDELIMC || \
                              (o)==OPT_UNDELIMV )

	/* -------------------------------------------------- */
	/*    OPTVALUE: a macro to get the value of an option */
	/* SETOPTVALUE: a macro to set the value of an option */
	/* -------------------------------------------------- */

#define	OPTVALUE(typ,i)		((typ)(*((typ *)(optlist[i].value))))

#define SETOPTVALUE(typ,i,val)  { typ *xptr;                     \
                                  xptr = (typ *)(optlist[i].value); \
                                  *xptr = val; }

        /* ------------------------------- */
        /* Routine to register each option */
        /* ------------------------------- */

int optreg(void *val, opt_TYPE otype, char name, char *descript) {
    return optrega(val,otype,name,NULL,descript);
}
int optregc(void *val, opt_TYPE otype, char name) {
    return optrega(val,otype,name,NULL,NULL);
}
int optregcb(void *val, opt_TYPE otype, char name, char *descript) {
    return optrega(val,otype,name,NULL,descript);
}
int optregs(void *val, opt_TYPE otype, char *longname) {
    return optrega(val,otype,'\0',longname,longname);
}
int optregsb(void *val, opt_TYPE otype, char *longname, char *descript) {
    return optrega(val,otype,'\0',longname,descript);
}
int optexec(char *longname, OPT_PFI fcn, char *descript)
{
    int n;
    n = optrega(NULL,OPT_NUL,'\0',longname,descript);
    opthook_n(n,fcn);
    return n;
}
     
int
optrega(void *val, opt_TYPE otype, char name, char *longname, char *descript)
{
    char *thename=BLANKSTRING;

    if (name != '\0') {
        thename = strdup(".");
        thename[0] = name;
        thename[1] = '\0';
    } else if (!ISEMPTYSTRING(longname)) {
        thename = strdup(longname);
    } else if (!ISEMPTYSTRING(descript)) {
        thename = strdup(descript);
    }
    
    if( opt_nreg >= MAXOPTS )
        opt_fatal("optrega: too many options");
	
    if( name != '\0' && opt_char_number(name) != -1 ) {
        opt_warn_1("optrega: Duplicate option name \'%c\'",name);
    }
    /* This is probably a mistake to print out a warning message,
       since it will be printed every time the program is run.
       Perhaps it should only be run if the user types 'run --testopt'
       */
#if 0    
    if( val != NULL  && opt_val_number(val) != -1) {
        opt_warn_1("optrega: This variable [%s] has already been registered",
                   thename);
    }
#endif    
    
    /* Programmer may specify that an option is to be an
     * undelimted option by setting the name to '\0'
     */
    if(name=='\0' && ISEMPTYSTRING(longname)) {
        if(otype==OPT_STRING)  otype=OPT_UNDELIM;
        if(otype==OPT_VSTRING) otype=OPT_UNDELIM;
        if(otype==OPT_CSTRING) otype=OPT_UNDELIMC;
    }

    /* Having checked for various warnings, now register the options */

    optlist[opt_nreg].value         = val;
    optlist[opt_nreg].type          = otype;
    optlist[opt_nreg].name          = name;
    optlist[opt_nreg].longname      = longname;
    optlist[opt_nreg].descript      = descript;
    optlist[opt_nreg].help          = NULL;
    optlist[opt_nreg].hook          = NULL;
    optlist[opt_nreg].invoked       = 0;
    
    /* UN-delimited strings are set to NULL when registered */
    /* This enables them to be invoked on the command line  */
    
    if (val != NULL) {
        if(otype==OPT_UNDELIMC) *((char *)optlist[opt_nreg].value)='\0';
        if(otype==OPT_UNDELIM ||
           otype==OPT_UNDELIMV) SETOPTVALUE(char *,opt_nreg,NULL);
    }
    ++opt_nreg;
    return opt_nreg-1;

}
void optchar_n(int n, char name)
{
    if (ISVALIDNUMBER(n)) optlist[n].name = name;
}    
void optdescript_n(int n, char *descript)
{
    if (ISVALIDNUMBER(n)) optlist[n].descript = strdup(descript);
}
void opthelp_n(int n, char *help)
{
    if (ISVALIDNUMBER(n)) optlist[n].help = strdup(help);
}
void optlongname_n(int n, char *longname)
{
    if (ISVALIDNUMBER(n)) optlist[n].longname = strdup(longname);
}
void opthook_n(int n, OPT_PFI hook)
{
    if (ISVALIDNUMBER(n)) optlist[n].hook = hook;
}
int optinvoked_n(int n)
{
    if (ISVALIDNUMBER(n))
        return optlist[n].invoked;
    return 0;
}

int optinvoked(void *v) { return optinvoked_n( opt_number(v) ); }

void optchar(void *v,  char name) { optchar_n( opt_number(v),   name ); }
void opthelp(void *v,  char *help) { opthelp_n( opt_number(v),  help ); }
void opthook(void *v,  OPT_PFI hook) { opthook_n( opt_number(v), hook ); }      
void optlongname(void *v, char *longname)
{
    optlongname_n( opt_number(v), longname );
}
void optdescript(void *v, char *descript)
{
    optdescript_n( opt_number(v), descript );
}
void optExitNumber(int n) {
    opt_exit_number = n;
}


#if 0
/* opt_valid_longname: currently not used, but we should make sure
 * there are no whitespaces or funny characters
 */
static int opt_valid_longname(char *name)
{
    
    return 1;
}
#endif

void
opt_get_help(char c)
{
    int n;
    n = opt_char_number(c);
    if (ISVALIDNUMBER(n) && optlist[n].help != NULL)
        opt_mess_2("%c: %s\n",c,optlist[n].help);
    else
        opt_mess_1("Help unavailable for \'%c\'\n",c);
}
	
	

/* opt_XXX_number(): Get number corresponding to option name; return
 * a value of -1 if the option does not exist.
 *  opt_char_number(c) takes as input the single-character name;
 *  opt_longname_number(longname) takes as input the long name
 *  opt_number(void *) takes as input pointer to variable
 */

int
opt_char_number(char c)
{
    int i;                         /* see which registered option */
    for(i=0; i<opt_nreg; ++i) {
        if( c == optlist[i].name )
            return i;
    }
    return -1;
}
    
static int
opt_number(void *v)
{
    int i;                         /* see which registered option */
    for(i=0; i<opt_nreg; ++i) {
        if( v == optlist[i].value )
            return i;
    }
    return -1;                     /* to signify not an option */
}
static int
opt_longname_number(char *s)
{
    int i;                         /* see which registered option */
    if ( ISEMPTYSTRING(s) ) return -1;
    for(i=0; i<opt_nreg; ++i) {
        if ( !ISEMPTYSTRING(optlist[i].longname) ) {
            if (0==strcmp(s,optlist[i].longname)) {
                return i;
            }
        }
    }
    return -1;                     /* to signify not an option */
}




	/* -------------------------------------------- */
	/* Print value of registered option to a string */
	/* -------------------------------------------- */

/* optstrval:
 * returns the value of the ith registered option as a string
 * Thus if x = 12.6, this returns the string "12.6"
 * The return value is a pointer to a static string which is
 * overwritten with each call
 * FLAG values are returned as "+" or "-"
 * INTLEVEL values are returned as "- -xxxx..." depending on value
 */
char *
optstrval(int i)
{
    int maybe;
    static char stval_buf[80];
    
    switch( optlist[i].type ) {
    case OPT_INT:
        sprintf(stval_buf,"%d", OPTVALUE(int,i) );
        break;
    case OPT_UINT:
    case OPT_UNSINT:
        sprintf(stval_buf,"%u", OPTVALUE(unsigned int,i) );
        break;
    case OPT_SHORT:
        sprintf(stval_buf,"%d", OPTVALUE(short,i) );
        break;
    case OPT_USHORT:
        sprintf(stval_buf,"%u", OPTVALUE(unsigned short,i) );
        break;
    case OPT_LONG:
        sprintf(stval_buf,"%ld", OPTVALUE(long,i) );
        break;
    case OPT_ULONG:
        sprintf(stval_buf,"%lu", OPTVALUE(unsigned long,i) );
        break;
    case OPT_CHAR:
        sprintf(stval_buf,"%c", OPTVALUE(char,i));
        break;
    case OPT_UCHAR:
        sprintf(stval_buf,"%c", OPTVALUE(unsigned char,i));
        break;
    case OPT_FLOAT:
        sprintf(stval_buf,"%g", OPTVALUE(float,i) );
        break;
    case OPT_DOUBLE:
        sprintf(stval_buf,"%g", OPTVALUE(double,i) );
        break;
    case OPT_INTLEVEL:
        if (1) {
            int j;
            char buff[80];
            strcpy(stval_buf,"-"); 		/* Begin with level==OFF */
            for(j=0; j< OPTVALUE(int,i); ++j) {
                sprintf(buff,(j==0?" -%c":"%c"),optlist[i].name);
                strcat(stval_buf,buff);
            }
        }
        break;
    case OPT_FLAG:
    case OPT_ABSFLAG:
        maybe = OPTVALUE(int,i);
        sprintf(stval_buf,"%c", (maybe==OPT_TRUE ? FLAG_TRUE : FLAG_FALSE) );
        break;
    case OPT_NEGFLAG:
    case OPT_ABSNEGFLAG:
        maybe = OPTVALUE(int,i);
        sprintf(stval_buf,"%c", (maybe==OPT_TRUE ? FLAG_FALSE : FLAG_TRUE) );
        break;
    case OPT_CSTRING:    
    case OPT_UNDELIMC:
        /* OPTVALUE(char *,i) macro doesn't work for CSTRING's */
        sprintf(stval_buf,"\"%s\"",(char *)optlist[i].value);
        break;
    case OPT_STRING:
    case OPT_VSTRING:
    case OPT_UNDELIM:
    case OPT_UNDELIMV:
        if( optlist[i].value == NULL )	/* this should never happen */
            sprintf(stval_buf,"\"\"");
        else 
            if( OPTVALUE(char *,i) == NULL )
                sprintf(stval_buf,"\"\"");
            else
                sprintf(stval_buf,"\"%s\"",OPTVALUE(char *,i));
        break;
    case OPT_NUL:
        break;
    default:
        opt_fatal("optstrval: Undefined o-type");
        break;
    }
    /* ---- Return value is static buffer ---- */
    return stval_buf;
}/*optstrval*/


/* optstrtyp:
 * returns the type of the ith registered option as a string
 * Thus if x = 12.6 is a float , this returns the string "<real>"
 * The return value is a pointer to a static string which is
 * overwritten with each call
 */
char *
optstrtyp(int i)
{
    static char	sttyp_buf[80];

    switch( optlist[i].type ) {
        /* Integers */
    case OPT_INT:         strcpy(sttyp_buf,"<INT>"); break;
    case OPT_UNSINT:      /* deprecated, same as UINT */
    case OPT_UINT:        strcpy(sttyp_buf,"<UINT>"); break;
    case OPT_SHORT:       strcpy(sttyp_buf,"<SHORT>"); break;
    case OPT_LONG:        strcpy(sttyp_buf,"<LONG>"); break;
    case OPT_USHORT:      strcpy(sttyp_buf,"<USHORT>"); break;
    case OPT_ULONG:       strcpy(sttyp_buf,"<ULONG>"); break;
        /* Floating point */
    case OPT_FLOAT:       strcpy(sttyp_buf,"<FLOAT>"); break;
    case OPT_DOUBLE:      strcpy(sttyp_buf,"<DOUBLE>"); break;
        /* Char */
    case OPT_CHAR:        strcpy(sttyp_buf,"<CHAR>"); break;
    case OPT_UCHAR:       strcpy(sttyp_buf,"<UCHAR>"); break;
        /* Flag */
    case OPT_INTLEVEL:    strcpy(sttyp_buf,"<INTLEVEL>"); break;
    case OPT_FLAG:        strcpy(sttyp_buf,"<FLAG>"); break;
    case OPT_NEGFLAG:     strcpy(sttyp_buf,"<NEGFLAG>"); break;
    case OPT_ABSFLAG:     strcpy(sttyp_buf,"<ABSFLAG>"); break;
    case OPT_ABSNEGFLAG:  strcpy(sttyp_buf,"<ABSNEGFLAG>"); break;
        /* String */
    case OPT_STRING:      strcpy(sttyp_buf,"<STRING>"); break;
    case OPT_VSTRING:     strcpy(sttyp_buf,"<STRING>"); break;
    case OPT_CSTRING:     strcpy(sttyp_buf,"<STRING>"); break;
        /* Undelimited */
    case OPT_UNDELIM:     strcpy(sttyp_buf,"<UNDELIM>"); break;
    case OPT_UNDELIMV:    strcpy(sttyp_buf,"<UNDELIM>"); break;
    case OPT_UNDELIMC:    strcpy(sttyp_buf,"<UNDELIM>"); break;
        /* Nul */
    case OPT_NUL:         strcpy(sttyp_buf,"<NUL>"); break;
        
    default:
        opt_fatal("usage: undefined o-type");
    }
    return sttyp_buf;
}

		/* ------------------------------ */
		/* Put registered options to file */
		/* ------------------------------ */

void
opt_tofile(FILE *fp)
{
    int	i;
    char *format;
    /* Short Option Names */
    char *fnumstr="-%c %-38s %c%s\n";	/* numbers and strings  */
    char *fflgchr="-%c%-38s  %c%s\n";	/* flags and characters */
    
    opt_fileheader(fp);
    /* Short Option Names First */
    for(i=0; i<opt_nreg; ++i) {
        if (optlist[i].name == '\0')
            continue;
        if( OPT_isundelimtype( optlist[i].type ) )
            continue;
        if (optlist[i].type == OPT_NUL)
            continue;
        if( OPT_isflagtype( optlist[i].type )
            || optlist[i].type == OPT_INTLEVEL
            || optlist[i].type == OPT_CHAR )
            format = fflgchr;
        else
            format = fnumstr;
        fprintf(fp,format,optlist[i].name,
                optstrval(i),IGNOREEOL,optlist[i].descript);
        /* If an option has both a short and a long option name
         * then write it as a comment '    ; -b == --option-b
         */
        if (optlist[i].longname) {
            fprintf(fp,"%-42s%c -%c == --%s\n","",IGNOREEOL,
                    optlist[i].name,optlist[i].longname);
        }
    }
    /* Now Long Option Names (thanks to Jason V. Morgan) */
    for(i=0; i<opt_nreg; ++i) {
        /* do not output the long name if a short name exists */
        if (optlist[i].name != '\0')
           continue;
        if (!optlist[i].longname) 
           continue;

        /* The following arguably applies to short options too ?? */
        /* don't want anything with a hook (do we?) */
        if (optlist[i].type == OPT_NUL)
            continue;
        if (optlist[i].hook != NULL)
            continue;
        
        fprintf(fp, "--%s=%-*s %c%s\n", optlist[i].longname, 
                38 - strlen(optlist[i].longname), optstrval(i), 
                IGNOREEOL, optlist[i].descript);
    }
}
static void
opt_fileheader(FILE *fp)
{
    extern char *opt_program_name;
    int	i,n;
    char buf[80];

    sprintf(buf,"Options file created by: [%.30s]",opt_program_name);
    n = strlen(buf);

    fputc(IGNOREEOL,fp);
    fprintf(fp,"%s",buf);
    fputc(IGNOREEOL,fp); fputc('\n',fp);

    fputc(IGNOREEOL,fp);
    for(i=0;i<n;++i) fprintf(fp,"-");
	fputc(IGNOREEOL,fp); fputc('\n',fp);
}
		/* ----------------------------------------- */
		/* write options out to the interactive menu */
		/* ----------------------------------------- */

char *
opt_mstring(int i)
{
    static char mstring[180];
    char	flgstr[10];
    char	*s;
    char	*optstrval(int i);
    char	*format = "%c %-40s %s";
    char        *lformat = "  --%s %*s%s";

    if( OPT_isundelimtype( optlist[i].type ) )
		return NULL;

    s = optstrval(i);
    if( optlist[i].type == OPT_INTLEVEL ) {
        int f;
        f = OPTVALUE(int,i);
        if(f==0)
            strcpy(flgstr,"OFF");
        else if (f==1)
            strcpy(flgstr,"ON");
        else
            sprintf(flgstr,"ON:%d",f);
        s=flgstr;
    } else if( optlist[i].type == OPT_CHAR ) {
        switch (s[0]) {
        case '\0':	sprintf(flgstr,"\'\\0\'"); break;
        case '\n':	sprintf(flgstr,"\'\\n\'"); break;
        case '\t':	sprintf(flgstr,"\'\\t\'"); break;
        case ' ':	sprintf(flgstr,"\'  \'");  break;
        default:	sprintf(flgstr,"%c",s[0]); break;
        }
        s = flgstr;
    } else if( OPT_isflagtype( optlist[i].type ) ) {
        if( *s == '+' || *s == '1')
            strcpy(flgstr,"TRUE");
        if( *s == '-' || *s == '0')
            strcpy(flgstr,"FALSE");
        s=flgstr;
    }

    /* This needs to be fancier, since we now have many combinarions
     * of long/short name'd options
     */
    if (optlist[i].name) {
        sprintf(mstring,format,optlist[i].name,optlist[i].descript,s);
    } else if (optlist[i].longname) {
        sprintf(mstring,lformat,optlist[i].longname,
                38 - strlen(optlist[i].longname),"",s);
    }
            
    return mstring;
}
int
opt_fprint(FILE *fp, int i)
{
    fprintf(fp,"-%c%-17s %c%s\n",optlist[i].name,
            optstrval(i),IGNOREEOL,optlist[i].descript);
    return i;
}

/* opt_usage: Write a usage statement describing registered options.
 * This is what the program writes in response to '--help' on the
 * command line.
 */

#define OPTUSAGEDEBUG 0

void
opt_usage(void)
{
    static char *dformat = " -%c                 %-12s    %s\n";
    static char *lformat=         " -%c, --%-12s %-12s    %s\n";
    static char *uformat =  "                    %-12s    %s\n";
    static char *aformat =         "     --%-12s %-12s    %s\n";
    int  i;
    
    for(i=0; i<opt_nreg; ++i) {
        if(OPTUSAGEDEBUG) fprintf(stderr,"%2d ",i);
        if( OPT_isundelimtype( optlist[i].type ) ) {
            if(OPTUSAGEDEBUG) fprintf(stderr,"u ");
            opt_mess_2(uformat,optstrtyp(i),optlist[i].descript);
        } else {
            if (optlist[i].name == '\0') {
                    if(OPTUSAGEDEBUG) fprintf(stderr,"a ");
                    opt_mess_3(aformat,optlist[i].longname,
                               optstrtyp(i),optlist[i].descript);
            } else {
                if (!ISEMPTYSTRING(optlist[i].longname)) {
                    if(OPTUSAGEDEBUG) fprintf(stderr,"l ");
                    opt_mess_4(lformat,optlist[i].name,optlist[i].longname,
                               optstrtyp(i),optlist[i].descript);
                } else {
                    if(OPTUSAGEDEBUG) fprintf(stderr,"d ");
                    opt_mess_3(dformat,optlist[i].name,
                               optstrtyp(i),optlist[i].descript);
                }
            }
        }
    }
    if (opt_additional_usage_fcn != NULL) {
        /* precede additional usage by -- to indicate that we
         * are finished with the options
         */
        opt_message(" --\n");
        /* return value is ignored */
        (*opt_additional_usage_fcn)();
    }
}

	/* ----------------------- */
	/* Get and process options */
	/* ----------------------- */

	/*
	 * The routines below make use of the ARGVECTOR structure
	 * defined in "ag.h" to process the command line options
	 */
		
	/* -------------------------------------- */
	/* get and process an UN-delimited option */
	/* -------------------------------------- */

int
opt_undelim(ARGVECTOR *ag)
{
    int     i;
    char    *s;
 
    /* Find the first undelimited option that has not been invoked and
     * set that to the argument string.  Note that once an undelimited
     * option has been invoked, it cannot be un-invoked.
     */

    s = strdup( ag_s_advance(ag) );
    for (i=0; i<opt_nreg; ++i) {
        if (optlist[i].invoked) continue;
        if (optlist[i].type==OPT_UNDELIMC ) {
            strncpy( optlist[i].value, s , OPT_MAXSTRLEN);
            optlist[i].invoked += 1;
            return 1; /* success */
        }
        if (optlist[i].type==OPT_UNDELIM ||
            optlist[i].type==OPT_UNDELIMV) {
            /** optlist[i].value = strdup(s); <-- this fails! **/
            SETOPTVALUE(char *,i,strdup(s));
            optlist[i].invoked += 1;
            return 1; /* success */
        }
    }
    return 0; /* failed to find an uninvoked option */
}

		/* ---------------------------------- */
		/* get and process a delimited option */
		/* ---------------------------------- */

int
opt_delim(ARGVECTOR *ag)
{
    int      i;
    char     c;
 
    c = ag_c_advance(ag);   /* first character gives name of option */
    i = opt_char_number(c);      /* this is number of option w/ name 'c' */
 
    if(! ISVALIDNUMBER(i)) { /* if invalid option name */
        opt_warn_1("%c not a registered option name\n",c);
        return 0;
    }
    return opt_action(i,ag);
}


int
opt_longdelim(ARGVECTOR *ag)
{
    int      i;
    char     c;
    char     *sc,*scptr;

    /* this code parses input options of the form --var=value */
    
    sc = strdup(ag_s(ag));      /* long option name is a string */
    scptr = sc;
    while( !ag_eow(ag) ) {
        c=ag_c_advance(ag);
        if (c == '=') {
            *scptr = '\0';
            break;
        }
        ++scptr;
    }
    
    i  = opt_longname_number(sc);   /* this is number of option w/ name `sc' */
    if(! ISVALIDNUMBER(i)) {
        opt_warn_1("%s not a registered option name\n",sc);
        return 0;
    }

    return opt_action(i,ag);
}

static int
opt_action(int i, ARGVECTOR *ag)
{
    /* ------------- */
    /* act on option */
    /* ------------- */
    opt_TYPE  o;
    char      c;
    char      *s;
    int       yes,no,maybe,toggle;    /* flag values */

    if (!ISVALIDNUMBER(i)) {
        opt_warn_1("opt_action: invalid number %d\n",i);
        return 0; /* failure */
    }

    switch( o=optlist[i].type ) {
    case OPT_INT:
        SETOPTVALUE(int,i, argnextnum(ag)); 
        break;
    case OPT_UNSINT: /* deprecated */
    case OPT_UINT:
        SETOPTVALUE(unsigned int,i, argnextnum(ag));
        break;
    case OPT_SHORT:
        SETOPTVALUE(short,i, argnextnum(ag));
        break;
    case OPT_LONG:
        SETOPTVALUE(long,i, argnextnum(ag));
        break;
    case OPT_USHORT:
        SETOPTVALUE(unsigned short,i, argnextnum(ag));
        break;
    case OPT_ULONG:
        SETOPTVALUE(unsigned long,i, argnextnum(ag));
        break;
    case OPT_FLOAT:
        SETOPTVALUE(float,i, argnextnum(ag));
        break;
    case OPT_DOUBLE:
        SETOPTVALUE(double,i, argnextnum(ag));
        break;
    case OPT_CHAR:
        SETOPTVALUE(char,i, ag_c_advance(ag));
        break;
    case OPT_UCHAR:
        SETOPTVALUE(unsigned char,i, ag_c_advance(ag));
        break;

    case OPT_FLAG:
    case OPT_NEGFLAG:
    case OPT_ABSFLAG:
    case OPT_ABSNEGFLAG:
        /* define terms:
         * yes: value of flag when  ON
         * no:  value of flag when OFF
         * maybe:  present value of flag
         * toggle: negative of maybe
         */
        maybe  = OPTVALUE(int,i);
        toggle = (maybe==OPT_TRUE ? OPT_FALSE : OPT_TRUE);
        if( o==OPT_FLAG || o==OPT_ABSFLAG )
            yes=OPT_TRUE;
        else
            yes=OPT_FALSE;
        no = (yes==OPT_TRUE ? OPT_FALSE : OPT_TRUE);
        c = ag_c(ag);           /* character following 'c' */
        switch(c) {
        case '+':
        case '1':
            SETOPTVALUE(int,i,yes);
            ag_c_advance(ag);       /* eat the '+' */
            break;
        case '-':
        case '0':
            SETOPTVALUE(int,i,no);
            ag_c_advance(ag);       /* eat the '-' */
            break;
        default:
            if( o==OPT_ABSFLAG || o==OPT_ABSNEGFLAG ) {
                SETOPTVALUE(int,i,yes);
            } else {    /* otherwise toggle value */
                SETOPTVALUE(int,i,toggle);
            }
            break;
        }
        break;

    case OPT_INTLEVEL:
        SETOPTVALUE(int,i,OPTVALUE(int,i) + 1);  /* default is to increment */
        c = ag_c(ag);
        switch(c) {
        case '+':
            /* we've already incremented */
            ag_c_advance(ag);
            break;
        case '-':
            SETOPTVALUE(int,i,0);
            ag_c_advance(ag);
            break;
        case '0': case '1': case '2': case '3': case '4':
        case '5': case '6': case '7': case '8': case '9':
            SETOPTVALUE(int,i,c-'0');
            ag_c_advance(ag);
        default:
            break;
        }
        break;
        
    case OPT_STRING:
    case OPT_VSTRING:
        s = argnext(ag);
        SETOPTVALUE(char *,i,strdup(s));
        break;
    case OPT_CSTRING:
        strncpy( (char *)optlist[i].value , argnext(ag), OPT_MAXSTRLEN );
        break;
        
    case OPT_UNDELIMC:
    case OPT_UNDELIMV:
        opt_fatal("opt_action: can't process UNDELIM type");
        break;

    case OPT_NUL:
        break;
        
    default:
        opt_fatal("opt_delim: don't know this type");
        break;
    }


    /* Indicate that the option was invoked */
    optlist[i].invoked += 1;

    /* Run the hook if its defined */
    if (optlist[i].hook) {
        int retval;
        retval = optlist[i].hook(optlist[i].value);

        if (retval == OPT_ERROR) {
            /* do nothing for now */;
        }
        if (retval == OPT_ABORT && !menuflag)
            exit(opt_exit_number);
        if (retval == OPT_QUIT)
            opt_quit();
        if (retval == OPT_EXIT)
            exit(opt_exit_number);
    }
    
    return 1;                  /* success */
}



/* OPT v3.7: options parsing tool */
/*
 * Copyright (C) 1998, James Theiler (jt@lanl.gov)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 * 
 */
/* opt_regt.c */
/* Note: this file generated automatically from makeopth.pl */
/* Edits to this file may be lost! */
#include <opt.h>
// ++pac 
// inline 
int
optrega_UINT(unsigned int *v, char c, char *n, char *B) {
      return optrega(v,OPT_UINT,c,n,B);
}
// inline 
int
optreg_UINT(unsigned int *v, char c, char *B) {
      return optreg(v,OPT_UINT,c,B);
}
// inline 
int
optregc_UINT(unsigned int *v, char c) {
      return optregc(v,OPT_UINT,c);
}
// inline 
int
optregs_UINT(unsigned int *v, char *n) {
      return optregs(v,OPT_UINT,n);
}
// inline 
int
optregcb_UINT(unsigned int *v, char c, char *B) {
      return optregcb(v,OPT_UINT,c,B);
}
// inline 
int
optregsb_UINT(unsigned int *v, char *s, char *B) {
      return optregsb(v,OPT_UINT,s,B);
}
// inline 
int
optrega_UNSINT(unsigned int *v, char c, char *n, char *B) {
      return optrega(v,OPT_UNSINT,c,n,B);
}
// inline 
int
optreg_UNSINT(unsigned int *v, char c, char *B) {
      return optreg(v,OPT_UNSINT,c,B);
}
// inline 
int
optregc_UNSINT(unsigned int *v, char c) {
      return optregc(v,OPT_UNSINT,c);
}
// inline 
int
optregs_UNSINT(unsigned int *v, char *n) {
      return optregs(v,OPT_UNSINT,n);
}
// inline 
int
optregcb_UNSINT(unsigned int *v, char c, char *B) {
      return optregcb(v,OPT_UNSINT,c,B);
}
// inline 
int
optregsb_UNSINT(unsigned int *v, char *s, char *B) {
      return optregsb(v,OPT_UNSINT,s,B);
}
// inline 
int
optrega_INTLEVEL(int *v, char c, char *n, char *B) {
      return optrega(v,OPT_INTLEVEL,c,n,B);
}
// inline 
int
optreg_INTLEVEL(int *v, char c, char *B) {
      return optreg(v,OPT_INTLEVEL,c,B);
}
// inline 
int
optregc_INTLEVEL(int *v, char c) {
      return optregc(v,OPT_INTLEVEL,c);
}
// inline 
int
optregs_INTLEVEL(int *v, char *n) {
      return optregs(v,OPT_INTLEVEL,n);
}
// inline 
int
optregcb_INTLEVEL(int *v, char c, char *B) {
      return optregcb(v,OPT_INTLEVEL,c,B);
}
// inline 
int
optregsb_INTLEVEL(int *v, char *s, char *B) {
      return optregsb(v,OPT_INTLEVEL,s,B);
}
// inline 
int
optrega_UNDELIMV(char **v, char c, char *n, char *B) {
      return optrega(v,OPT_UNDELIMV,c,n,B);
}
// inline 
int
optreg_UNDELIMV(char **v, char c, char *B) {
      return optreg(v,OPT_UNDELIMV,c,B);
}
// inline 
int
optregc_UNDELIMV(char **v, char c) {
      return optregc(v,OPT_UNDELIMV,c);
}
// inline 
int
optregs_UNDELIMV(char **v, char *n) {
      return optregs(v,OPT_UNDELIMV,n);
}
// inline 
int
optregcb_UNDELIMV(char **v, char c, char *B) {
      return optregcb(v,OPT_UNDELIMV,c,B);
}
// inline 
int
optregsb_UNDELIMV(char **v, char *s, char *B) {
      return optregsb(v,OPT_UNDELIMV,s,B);
}
// inline 
int
optrega_ULONG(unsigned long *v, char c, char *n, char *B) {
      return optrega(v,OPT_ULONG,c,n,B);
}
// inline 
int
optreg_ULONG(unsigned long *v, char c, char *B) {
      return optreg(v,OPT_ULONG,c,B);
}
// inline 
int
optregc_ULONG(unsigned long *v, char c) {
      return optregc(v,OPT_ULONG,c);
}
// inline 
int
optregs_ULONG(unsigned long *v, char *n) {
      return optregs(v,OPT_ULONG,n);
}
// inline 
int
optregcb_ULONG(unsigned long *v, char c, char *B) {
      return optregcb(v,OPT_ULONG,c,B);
}
// inline 
int
optregsb_ULONG(unsigned long *v, char *s, char *B) {
      return optregsb(v,OPT_ULONG,s,B);
}
// inline 
int
optrega_USHORT(unsigned short *v, char c, char *n, char *B) {
      return optrega(v,OPT_USHORT,c,n,B);
}
// inline 
int
optreg_USHORT(unsigned short *v, char c, char *B) {
      return optreg(v,OPT_USHORT,c,B);
}
// inline 
int
optregc_USHORT(unsigned short *v, char c) {
      return optregc(v,OPT_USHORT,c);
}
// inline 
int
optregs_USHORT(unsigned short *v, char *n) {
      return optregs(v,OPT_USHORT,n);
}
// inline 
int
optregcb_USHORT(unsigned short *v, char c, char *B) {
      return optregcb(v,OPT_USHORT,c,B);
}
// inline 
int
optregsb_USHORT(unsigned short *v, char *s, char *B) {
      return optregsb(v,OPT_USHORT,s,B);
}
// inline 
int
optrega_ABSNEGFLAG(int *v, char c, char *n, char *B) {
      return optrega(v,OPT_ABSNEGFLAG,c,n,B);
}
// inline 
int
optreg_ABSNEGFLAG(int *v, char c, char *B) {
      return optreg(v,OPT_ABSNEGFLAG,c,B);
}
// inline 
int
optregc_ABSNEGFLAG(int *v, char c) {
      return optregc(v,OPT_ABSNEGFLAG,c);
}
// inline 
int
optregs_ABSNEGFLAG(int *v, char *n) {
      return optregs(v,OPT_ABSNEGFLAG,n);
}
// inline 
int
optregcb_ABSNEGFLAG(int *v, char c, char *B) {
      return optregcb(v,OPT_ABSNEGFLAG,c,B);
}
// inline 
int
optregsb_ABSNEGFLAG(int *v, char *s, char *B) {
      return optregsb(v,OPT_ABSNEGFLAG,s,B);
}
// inline 
int
optrega_INT(int *v, char c, char *n, char *B) {
      return optrega(v,OPT_INT,c,n,B);
}
// inline 
int
optreg_INT(int *v, char c, char *B) {
      return optreg(v,OPT_INT,c,B);
}
// inline 
int
optregc_INT(int *v, char c) {
      return optregc(v,OPT_INT,c);
}
// inline 
int
optregs_INT(int *v, char *n) {
      return optregs(v,OPT_INT,n);
}
// inline 
int
optregcb_INT(int *v, char c, char *B) {
      return optregcb(v,OPT_INT,c,B);
}
// inline 
int
optregsb_INT(int *v, char *s, char *B) {
      return optregsb(v,OPT_INT,s,B);
}
// inline 
int
optrega_VSTRING(char **v, char c, char *n, char *B) {
      return optrega(v,OPT_VSTRING,c,n,B);
}
// inline 
int
optreg_VSTRING(char **v, char c, char *B) {
      return optreg(v,OPT_VSTRING,c,B);
}
// inline 
int
optregc_VSTRING(char **v, char c) {
      return optregc(v,OPT_VSTRING,c);
}
// inline 
int
optregs_VSTRING(char **v, char *n) {
      return optregs(v,OPT_VSTRING,n);
}
// inline 
int
optregcb_VSTRING(char **v, char c, char *B) {
      return optregcb(v,OPT_VSTRING,c,B);
}
// inline 
int
optregsb_VSTRING(char **v, char *s, char *B) {
      return optregsb(v,OPT_VSTRING,s,B);
}
// inline 
int
optrega_UNDELIM(char **v, char c, char *n, char *B) {
      return optrega(v,OPT_UNDELIM,c,n,B);
}
// inline 
int
optreg_UNDELIM(char **v, char c, char *B) {
      return optreg(v,OPT_UNDELIM,c,B);
}
// inline 
int
optregc_UNDELIM(char **v, char c) {
      return optregc(v,OPT_UNDELIM,c);
}
// inline 
int
optregs_UNDELIM(char **v, char *n) {
      return optregs(v,OPT_UNDELIM,n);
}
// inline 
int
optregcb_UNDELIM(char **v, char c, char *B) {
      return optregcb(v,OPT_UNDELIM,c,B);
}
// inline 
int
optregsb_UNDELIM(char **v, char *s, char *B) {
      return optregsb(v,OPT_UNDELIM,s,B);
}
// inline 
int
optrega_NUL(void *v, char c, char *n, char *B) {
      return optrega(v,OPT_NUL,c,n,B);
}
// inline 
int
optreg_NUL(void *v, char c, char *B) {
      return optreg(v,OPT_NUL,c,B);
}
// inline 
int
optregc_NUL(void *v, char c) {
      return optregc(v,OPT_NUL,c);
}
// inline 
int
optregs_NUL(void *v, char *n) {
      return optregs(v,OPT_NUL,n);
}
// inline 
int
optregcb_NUL(void *v, char c, char *B) {
      return optregcb(v,OPT_NUL,c,B);
}
// inline 
int
optregsb_NUL(void *v, char *s, char *B) {
      return optregsb(v,OPT_NUL,s,B);
}
// inline 
int
optrega_SHORT(short *v, char c, char *n, char *B) {
      return optrega(v,OPT_SHORT,c,n,B);
}
// inline 
int
optreg_SHORT(short *v, char c, char *B) {
      return optreg(v,OPT_SHORT,c,B);
}
// inline 
int
optregc_SHORT(short *v, char c) {
      return optregc(v,OPT_SHORT,c);
}
// inline 
int
optregs_SHORT(short *v, char *n) {
      return optregs(v,OPT_SHORT,n);
}
// inline 
int
optregcb_SHORT(short *v, char c, char *B) {
      return optregcb(v,OPT_SHORT,c,B);
}
// inline 
int
optregsb_SHORT(short *v, char *s, char *B) {
      return optregsb(v,OPT_SHORT,s,B);
}
// inline 
int
optrega_LONG(long *v, char c, char *n, char *B) {
      return optrega(v,OPT_LONG,c,n,B);
}
// inline 
int
optreg_LONG(long *v, char c, char *B) {
      return optreg(v,OPT_LONG,c,B);
}
// inline 
int
optregc_LONG(long *v, char c) {
      return optregc(v,OPT_LONG,c);
}
// inline 
int
optregs_LONG(long *v, char *n) {
      return optregs(v,OPT_LONG,n);
}
// inline 
int
optregcb_LONG(long *v, char c, char *B) {
      return optregcb(v,OPT_LONG,c,B);
}
// inline 
int
optregsb_LONG(long *v, char *s, char *B) {
      return optregsb(v,OPT_LONG,s,B);
}
// inline 
int
optrega_ABSFLAG(int *v, char c, char *n, char *B) {
      return optrega(v,OPT_ABSFLAG,c,n,B);
}
// inline 
int
optreg_ABSFLAG(int *v, char c, char *B) {
      return optreg(v,OPT_ABSFLAG,c,B);
}
// inline 
int
optregc_ABSFLAG(int *v, char c) {
      return optregc(v,OPT_ABSFLAG,c);
}
// inline 
int
optregs_ABSFLAG(int *v, char *n) {
      return optregs(v,OPT_ABSFLAG,n);
}
// inline 
int
optregcb_ABSFLAG(int *v, char c, char *B) {
      return optregcb(v,OPT_ABSFLAG,c,B);
}
// inline 
int
optregsb_ABSFLAG(int *v, char *s, char *B) {
      return optregsb(v,OPT_ABSFLAG,s,B);
}
// inline 
int
optrega_UNDELIMC(char *v, char c, char *n, char *B) {
      return optrega(v,OPT_UNDELIMC,c,n,B);
}
// inline 
int
optreg_UNDELIMC(char *v, char c, char *B) {
      return optreg(v,OPT_UNDELIMC,c,B);
}
// inline 
int
optregc_UNDELIMC(char *v, char c) {
      return optregc(v,OPT_UNDELIMC,c);
}
// inline 
int
optregs_UNDELIMC(char *v, char *n) {
      return optregs(v,OPT_UNDELIMC,n);
}
// inline 
int
optregcb_UNDELIMC(char *v, char c, char *B) {
      return optregcb(v,OPT_UNDELIMC,c,B);
}
// inline 
int
optregsb_UNDELIMC(char *v, char *s, char *B) {
      return optregsb(v,OPT_UNDELIMC,s,B);
}
// inline 
int
optrega_UCHAR(unsigned char *v, char c, char *n, char *B) {
      return optrega(v,OPT_UCHAR,c,n,B);
}
// inline 
int
optreg_UCHAR(unsigned char *v, char c, char *B) {
      return optreg(v,OPT_UCHAR,c,B);
}
// inline 
int
optregc_UCHAR(unsigned char *v, char c) {
      return optregc(v,OPT_UCHAR,c);
}
// inline 
int
optregs_UCHAR(unsigned char *v, char *n) {
      return optregs(v,OPT_UCHAR,n);
}
// inline 
int
optregcb_UCHAR(unsigned char *v, char c, char *B) {
      return optregcb(v,OPT_UCHAR,c,B);
}
// inline 
int
optregsb_UCHAR(unsigned char *v, char *s, char *B) {
      return optregsb(v,OPT_UCHAR,s,B);
}
// inline 
int
optrega_NEGFLAG(int *v, char c, char *n, char *B) {
      return optrega(v,OPT_NEGFLAG,c,n,B);
}
// inline 
int
optreg_NEGFLAG(int *v, char c, char *B) {
      return optreg(v,OPT_NEGFLAG,c,B);
}
// inline 
int
optregc_NEGFLAG(int *v, char c) {
      return optregc(v,OPT_NEGFLAG,c);
}
// inline 
int
optregs_NEGFLAG(int *v, char *n) {
      return optregs(v,OPT_NEGFLAG,n);
}
// inline 
int
optregcb_NEGFLAG(int *v, char c, char *B) {
      return optregcb(v,OPT_NEGFLAG,c,B);
}
// inline 
int
optregsb_NEGFLAG(int *v, char *s, char *B) {
      return optregsb(v,OPT_NEGFLAG,s,B);
}
// inline 
int
optrega_FLOAT(float *v, char c, char *n, char *B) {
      return optrega(v,OPT_FLOAT,c,n,B);
}
// inline 
int
optreg_FLOAT(float *v, char c, char *B) {
      return optreg(v,OPT_FLOAT,c,B);
}
// inline 
int
optregc_FLOAT(float *v, char c) {
      return optregc(v,OPT_FLOAT,c);
}
// inline 
int
optregs_FLOAT(float *v, char *n) {
      return optregs(v,OPT_FLOAT,n);
}
// inline 
int
optregcb_FLOAT(float *v, char c, char *B) {
      return optregcb(v,OPT_FLOAT,c,B);
}
// inline 
int
optregsb_FLOAT(float *v, char *s, char *B) {
      return optregsb(v,OPT_FLOAT,s,B);
}
// inline 
int
optrega_STRING(char **v, char c, char *n, char *B) {
      return optrega(v,OPT_STRING,c,n,B);
}
// inline 
int
optreg_STRING(char **v, char c, char *B) {
      return optreg(v,OPT_STRING,c,B);
}
// inline 
int
optregc_STRING(char **v, char c) {
      return optregc(v,OPT_STRING,c);
}
// inline 
int
optregs_STRING(char **v, char *n) {
      return optregs(v,OPT_STRING,n);
}
// inline 
int
optregcb_STRING(char **v, char c, char *B) {
      return optregcb(v,OPT_STRING,c,B);
}
// inline 
int
optregsb_STRING(char **v, char *s, char *B) {
      return optregsb(v,OPT_STRING,s,B);
}
// inline 
int
optrega_CSTRING(char *v, char c, char *n, char *B) {
      return optrega(v,OPT_CSTRING,c,n,B);
}
// inline 
int
optreg_CSTRING(char *v, char c, char *B) {
      return optreg(v,OPT_CSTRING,c,B);
}
// inline 
int
optregc_CSTRING(char *v, char c) {
      return optregc(v,OPT_CSTRING,c);
}
// inline 
int
optregs_CSTRING(char *v, char *n) {
      return optregs(v,OPT_CSTRING,n);
}
// inline 
int
optregcb_CSTRING(char *v, char c, char *B) {
      return optregcb(v,OPT_CSTRING,c,B);
}
// inline 
int
optregsb_CSTRING(char *v, char *s, char *B) {
      return optregsb(v,OPT_CSTRING,s,B);
}
// inline 
int
optrega_FLAG(int *v, char c, char *n, char *B) {
      return optrega(v,OPT_FLAG,c,n,B);
}
// inline 
int
optreg_FLAG(int *v, char c, char *B) {
      return optreg(v,OPT_FLAG,c,B);
}
// inline 
int
optregc_FLAG(int *v, char c) {
      return optregc(v,OPT_FLAG,c);
}
// inline 
int
optregs_FLAG(int *v, char *n) {
      return optregs(v,OPT_FLAG,n);
}
// inline 
int
optregcb_FLAG(int *v, char c, char *B) {
      return optregcb(v,OPT_FLAG,c,B);
}
// inline 
int
optregsb_FLAG(int *v, char *s, char *B) {
      return optregsb(v,OPT_FLAG,s,B);
}
// inline 
int
optrega_DOUBLE(double *v, char c, char *n, char *B) {
      return optrega(v,OPT_DOUBLE,c,n,B);
}
// inline 
int
optreg_DOUBLE(double *v, char c, char *B) {
      return optreg(v,OPT_DOUBLE,c,B);
}
// inline 
int
optregc_DOUBLE(double *v, char c) {
      return optregc(v,OPT_DOUBLE,c);
}
// inline 
int
optregs_DOUBLE(double *v, char *n) {
      return optregs(v,OPT_DOUBLE,n);
}
// inline 
int
optregcb_DOUBLE(double *v, char c, char *B) {
      return optregcb(v,OPT_DOUBLE,c,B);
}
// inline 
int
optregsb_DOUBLE(double *v, char *s, char *B) {
      return optregsb(v,OPT_DOUBLE,s,B);
}
// inline 
int
optrega_CHAR(char *v, char c, char *n, char *B) {
      return optrega(v,OPT_CHAR,c,n,B);
}
// inline 
int
optreg_CHAR(char *v, char c, char *B) {
      return optreg(v,OPT_CHAR,c,B);
}
// inline 
int
optregc_CHAR(char *v, char c) {
      return optregc(v,OPT_CHAR,c);
}
// inline 
int
optregs_CHAR(char *v, char *n) {
      return optregs(v,OPT_CHAR,n);
}
// inline 
int
optregcb_CHAR(char *v, char c, char *B) {
      return optregcb(v,OPT_CHAR,c,B);
}
// inline 
int
optregsb_CHAR(char *v, char *s, char *B) {
      return optregsb(v,OPT_CHAR,s,B);
}
/* OPT v3.7: options parsing tool */
/*
 * Copyright (C) 1998, James Theiler (jt@lanl.gov)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 * 
 */
/* $Id: opt.c,v 1.1 1998/09/19 04:10:07 jt Exp $ */
/* opt_menu.c */


#ifndef	SINGLEFILE
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#ifdef convex
#include <strings.h>
#else
#include <string.h>
#endif
#ifdef __TURBOC__
#include <alloc.h>
#endif
#include "opt.h"
#include "ag.h"
#include "opt_p.h"
#endif /* SINGLEFILE */

/* --------------------- menu flag ------------------- */

flag menuflag=False;

static char mgstring[160];	/* global menu string */

#define menu_wr_string(str)       opt_message(str)
#define menu_getresponse(respond) opt_getline(respond,stdin)

static void write_the_menu(int iopfrom, int iopto);
static int auto_prefix_delim(char *r);


/* ----------------------------------------------------	*/
/*  opt_menu:	Get options from an interactive menu	*/
/* ----------------------------------------------------	*/

#define	MAXRESPONDLINE	280
#ifndef	MAXOPTSINMENU
#define	MAXOPTSINMENU	20
#endif
#define MENUPROMPT "-> "

void
opt_menu(void)
{
    char respond[MAXRESPONDLINE+2];
    static int maxoptsinmenu=MAXOPTSINMENU;
    int	iopfrom,iopto;

    menuflag=True;	/* turn on MENUFLAG in case it is not set already */
    
    iopfrom = 0;
    iopto = ( opt_nreg < maxoptsinmenu ? opt_nreg : maxoptsinmenu );
    
    respond[0]='\0';

    opt_mess_1("%s\n",optgetTitle());
    write_the_menu(iopfrom,iopto);

    while( menuflag ) {
        opt_menu_getresponse(MENUPROMPT,respond,MAXRESPONDLINE);
		
        switch(*respond) {
        case ADDITIONAL_OPTS:
            if( respond[1] != '\0' && respond[1] != ' ' ) {
                maxoptsinmenu = atoi(respond+1);
                if(maxoptsinmenu < 1)
                    maxoptsinmenu = opt_nreg;
                sprintf(mgstring,"Scroll %d options\n",maxoptsinmenu);
                menu_wr_string(mgstring);
                iopfrom = 0;
                iopto = 
                    ( opt_nreg < maxoptsinmenu ? opt_nreg : maxoptsinmenu );
            } else {
                iopfrom += maxoptsinmenu;
                if( iopfrom > opt_nreg)
                    iopfrom = 0;
                iopto = iopfrom + maxoptsinmenu;
                if( iopto > opt_nreg )
                    iopto = opt_nreg;
            }
            write_the_menu(iopfrom,iopto);
            break;
        case INTERACT:
            menuflag=False;
            break;
        case BANG:
            system( respond+1 );
            break;
        case '\0':
            write_the_menu(iopfrom,iopto);
            break;
        case QUITCH:
            /* Only quit if the QUITCH is followed by whitespace.  In
             * other words, if respond = '.m=5', don't quit.  However,
             * note that respond = '. m=5' will cause a quit.
             */
            if ( respond[1]=='\0' || respond[1]==' ' )
                opt_quit();
            else
                opt_mess_1("Invalid line: [%s]\n",respond);
            break;
        case DELIM:
#ifdef PERMIT_ALTDELIM            
        case ALTDELIM:
#endif            
            opt_lineprocess(respond);
            break;
        default:
            auto_prefix_delim(respond);
            opt_lineprocess(respond);
            break;
        }
    }
}/* opt_menu */


/**********
 * write_the_menu:
 *	write the menu including options from iopfrom to iopto.
 */
static void
write_the_menu(int iopfrom, int iopto)
{
    int iop;
    flag fullmenu;

    fullmenu = ((iopfrom==0 && iopto==opt_nreg) ? True : False );

    if( !fullmenu ) {
        sprintf(mgstring,"menu: %d->%d [%d]\n",iopfrom,iopto,opt_nreg);
        menu_wr_string(mgstring);
    }

    for(iop=iopfrom; iop<iopto; ++iop) {
        char *s;
        s = opt_mstring(iop);
        if (s!=NULL) {
            strcpy( mgstring, s );
            menu_wr_string(mgstring);
            menu_wr_string("\n");
        }
    }
    if (!fullmenu) {
        sprintf(mgstring,"%c Additional options\n",ADDITIONAL_OPTS);
        menu_wr_string(mgstring);
    }
    sprintf(mgstring,"(Type %c for Help)\n",HELPCH);
    menu_wr_string(mgstring);
}

/*	auto_prefix_delim:	
 *		this is a fru-fru piece of code that automatically
 *		sticks a DELIM character onto the front of a string
 *		in cases where it imagines that that is what the user
 *		really meant.  Thus
 *		-> m4
 *		gives the same effect as
 *		-> -m4
 *		But be warned that this only applies in limited cases.
 *		Eg.,
 *		-> m4 b3
 *		is not the same as
 *		-> -m4 -b3
 *
 *		a '-' will be prepended in the case that 
 *		the first character is a registered name
 */
static int
auto_prefix_delim(char *r)
{
    if( opt_char_number( *r ) != -1 ) {
        int len;
        len = strlen(r)+1;	/* +1 since double terminated */
        while(len>=0) {
            r[len+1]=r[len];
            --len;
        }
        r[0]=DELIM;
        return(1);
    }
    else
        return(0);
}/* auto_prefix_delim */


/* OPT v3.7: options parsing tool */
/*
 * Copyright (C) 1998, James Theiler (jt@lanl.gov)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 * 
 */
/* $Id: opt.c,v 1.1 1998/09/19 04:10:07 jt Exp $ */
/* opt_proc.c */
/*
 *	process options in the OPT package
 */

#ifndef	SINGLEFILE
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#ifdef convex
#include <strings.h>
#else
#include <string.h>
#endif
#ifdef __TURBOC__
#include <alloc.h>
#include <stdarg.h>
#endif
#include "opt.h"
#include "ag.h"
#include "opt_p.h"
#endif /* SINGLEFILE */

/******************
 * Global variables 
 */

char	*opt_program_name = NULL;
flag	opt_fileflag = False;

char	*optfile_name = NULL;
char    *opt_defaultfile = NULL;
char    *opt_titlestring = NULL;
char    *opt_usagestring = NULL;
char	*opt_envstring=NULL;
char	*opt_defstring=NULL;

OPT_PFI     opt_additional_usage_fcn=NULL;
OPT_PFI	    opt_quit_fcn=NULL;
OPT_PFI	    opt_run_fcn=NULL;
OPT_PFI_ARG opt_main_fcn=NULL;

/****************************
 * Static Function prototypes 
 */

static char *append_string(char *, char *);
static int  line2argv(int *, char ***, char *);
static int  l2a(char *, char **);
static flag break_word(flag, char *);
static int  backup_file(char *fname);



/***************************
 * set title, usage, etc.  *
 ***************************/
void
optTitle(char *s)
{
    opt_titlestring = strdup(s);
}
char *
optgetTitle(void)
{
    if (!ISEMPTYSTRING(opt_titlestring))
        return opt_titlestring;
    else
        return opt_program_name;
}
void
optUsage(char *s)
{
    opt_usagestring = strdup(s);
}
void
optEnvVarName(char *s)
{
    opt_envstring = strdup(s);
}
void
optDefaultString(char *s)
{
    opt_defstring = strdup(s);
}
void
optDefaultFile(char *s)
{
    opt_defaultfile = strdup(s);
}
void
optQuit(OPT_PFI fcn)
{
    opt_quit_fcn = fcn;
}
void
optRun(OPT_PFI fcn)
{
    opt_run_fcn = fcn;
}
void
optMain(OPT_PFI_ARG fcn)
{
    opt_main_fcn = fcn;
}
void
optAdditionalUsage(OPT_PFI fcn)
{
    opt_additional_usage_fcn = fcn;
}



/* ------------------------------------------------------------------ */

/* getopts:
 * This routine is maintained only for backward compatibility.  It
 * takes argc, argv and returns the new value of argc; Now, it is
 * recommended that you use opt(), which takes &argc,&argv as arguments,
 * and then returns new argc,argv through the pointers on the arg list.
 */
int
getopts(int argc, char **argv)
{
    
	/*
	 * Before processing, set the global variables
	 * opt_program_name : name of routine that is running
	 * optfile_name     : default name of options file
	 */
    opt_program_name = short_progname(argv[0]);
    optfile_name = append_string(opt_program_name,OPT_EXT);
    opt_readline_init(opt_program_name);
                                               
	/* Begin options processing */
	/* ------------------------ */

    /* First process default string */
    opt_lineprocess(opt_defstring);

    /* Second, check environment variable */
    if(opt_envstring != NULL) {
	char	*s;
	char	*getenv(const char *);
	
	s = getenv(opt_envstring);
	opt_lineprocess(s);
    }

    /* Finally, parse the command line */
    opt_process(argc-1,argv+1);

    return(argc);
}
/*
 * opt: This is the routine that does all the work.  It is generally called
 * from main(), after all calls to optreg() have been made.
 * It returns nothing, but new argc/argv are returned via the arglist
 */
void
opt(int *argcptr, char ***argvptr)
{
    int	 argc;
    char **argv;
    ARGVECTOR *ag;
    
    argc = *argcptr;
    argv = *argvptr;

    /*
     * Before processing, set the global variables
     * opt_program_name : name of routine that is running
     * optfile_name     : default name of options file
     */
    opt_program_name = short_progname(argv[0]);
    optfile_name = append_string(opt_program_name,OPT_EXT);
    opt_readline_init(opt_program_name);
                                               
    /* Begin options processing */
    /* ------------------------ */

    /* First process default string */
    opt_lineprocess(opt_defstring);

    /* Second, check the default file (eg ~/.programrc) */
    if (!ISEMPTYSTRING(opt_defaultfile)) {
        opt_fromfname(opt_defaultfile);
    }
    
    /* Third, check environment variable */
    if(opt_envstring != NULL)
    {
	char	*s;
	s = getenv(opt_envstring);
	opt_lineprocess(s);
    }

    /* Finally, parse the command line */
    if (argc == 0) return;      /* assuming there is one... */
    ag = opt_process(argc-1,argv+1);
    /* And, return the leftover argc/argv, but first prepend argv[0]
     * to this!
     */
    if (ag == NULL) {
        *argcptr = 1;
        *argvptr = argv;
    } else {
        /* make a new argc,argv */
        ARGVECTOR *agnew;
        agnew = ag_prepend_argv0(ag,argv[0]);
        *argcptr = ag_argc(agnew);
        *argvptr = ag_argv(agnew);
        ag_free(agnew);         /* don't ag_freeall(agnew) because
                                 * that will ruin the new argv strings
                                 */
    }
    ag_free(ag);
    

}
static char *
append_string(char *s, char *t)
{
    /* input two strings "s" and "t":
     * concatenates them to get string "st"
     * which it allocates space for and returns
     */
    char *st;
    st = (char *)malloc( strlen(s)+strlen(t)+1 );
    strcpy(st,s);
    strcat(st,t);
    return(st);
}
char *
short_progname(char *pname)
{
    char *p;
    int	len;

    /*
     * inelegant routine
     * returns the shortened name of the program named [pname].
     * It (recursively) strips off leading directory or drive number
     * and trailing ".EXE" in the case of MS-DOS executable
     */

    p = pname;
    while( *p != '/' && *p!='\\' && *p!=':' && *p!='\0' )
    	++p;
    if( *p=='\0') {	/* remove .EXE if it exists */
    	len = strlen(pname);
    	if( len > 4 ) {
    	    if( ( 0==strcmp(pname+len-4,".EXE") ||
    	    	  0==strcmp(pname+len-4,".exe") ) )
    	    		pname[len-4]='\0';
	}
    	return( pname );
    }
    else
    	return( short_progname(++p) );
}
/* ----------------------------------------------------------------- */

	/* ------- */
	/* process */
	/* ------- */

/****************************************************************
 * opt_process(): 
 *	INPUT:
 *		argc, argv;
 *
 *	this is the central receiving facility for the options package.
 *	opt_process takes an argument list given by (argc,argv) and
 *	and processes it,
 *	Although the input may come from either of
 *		system command line
 *		options file
 *		interactive command line
 *	the behavior is slightly different if the global menuflag is set
 */

ARGVECTOR *
opt_process(int argc, char **argv)
{
    char	c;
    int		iword;
    ARGVECTOR	*ag;
    
    /*
     * convert the argument vector (argc,argv) into
     * an ARGVECTOR structure, to ease manipulations
     */
    
    if( argc==0 )
        return (ARGVECTOR *)NULL;
    
    ag = ag_new(argc,argv);

    if(DEBUG) {
        ag_fprint(stderr,ag);
    }

    /* Loop through the options in the argument vector */
    
    while( !ag_end(ag) ) {	
        if( ag_eow(ag)	)		/* if necessary...      */
            ag_w_advance(ag);	        /* advance to next word */
		
        if(DEBUG)
            if( ag->ic != 0 )		/* this should never happen */
                opt_warning("opt_proc: not on first character");
		
        c=ag_c_advance(ag);		/* first character of word */
		
        /* ------ */
        /* switch */
        /* ------ */
		
        switch( c ) {
        case DELIM:
#ifdef PERMIT_ALTDELIM            
        case ALTDELIM:
#endif            
            if( ag_eow(ag) ) {
                /* unadorned "-" will be treated as an undelimited option */
                /* Try to process it as an undelimited option */
                if( opt_undelim(ag) == 0) {
                    /* if not successful...then stop processing */
                    ag_backword(ag);
                    return ag;
                }
            } else if( ag_c(ag) == c ) {
                ag_c_advance(ag);          /* eat the '-' */
                if (ag_eow(ag)) {          /* if unadorned "--" */
                    ag_w_advance(ag);      /* eat the entire "--" */
                    return ag;             /* and stop processing */
                    
                    /* if "--something" */                    
                } else {
                    /* Special cases: --help, --optVersion, --menu, etc.. */
                    if (0==strcmp("help",ag_s(ag))) { 
                        short_usage();
                        long_usage();
                        if (!menuflag)
                            optAbortRun();
                    } else if (0==strcmp("optVersion",ag_s(ag))) {
#ifdef VERSION                        
                        opt_mess_1("OPT Version %s\n",VERSION);
#endif
                        if (!menuflag)
                            optAbortRun();
                    } else if (0==strcmp("menu",ag_s(ag))) { /* --menu */
                        if ( !menuflag )      /* If not called already */
                            ag_w_advance(ag); /* Swallow the '--menu' */
                            opt_menu();       /* and call the menu */	
                    } else {
                        /* if a generic "--longoption" */
                        opt_longdelim(ag);
                    }
                }
                /* if "-something" */
            } else {
                iword = ag_w_number(ag);
                while( iword==ag_w_number(ag) && !ag_eow(ag) )
                    opt_delim(ag);
            }
            break;

        case OPTFROMFILE:
            if (! opt_fromfname(argnext(ag))) {
                opt_warn_1("Cannot open options file [%s]\n",optfile_name);
            }
            break;
            
        case OPTTOFILE:
            opt_tofname(argnext(ag));
            break;

        case HELPCH:
            if( !opt_fileflag)
                opt_help(argnext(ag));
            break;

        case INTERACT:
            if ( !menuflag )		/* If not called already */
                opt_menu();				/* Call the menu */	
            else {						/* otherwise */ 
                menuflag=False;			/* turn off menu */
                ag_clear(ag);
            }
            break;
        case IGNOREEOL:
            ag_clear(ag);
            break;
        case RUN:
            /* Give precedence to optMain, then optRun */
            if ( opt_main_fcn != NULL ) {
                int retval;
                int ac;
                char **av;
                ac = ag_argc(ag);
                av = ag_argv(ag);
                ag_clear(ag);
                retval = optBeginMain(opt_main_fcn,ac,av);
                if (retval == OPT_ABORT)
                    optAbortMain();
                if (retval == OPT_QUIT)
                    opt_quit();
                if (retval == OPT_EXIT)
                    exit(opt_exit_number);
            }
            else if ( opt_run_fcn != NULL ) {
                int retval;
                retval = optBeginRun(opt_run_fcn);
                if (retval == OPT_ABORT)
                    optAbortRun();
                if (retval == OPT_QUIT)
                    opt_quit();
                if (retval == OPT_EXIT)
                    exit(opt_exit_number);
            } 
            else {
                /* if opt_run_fcn is not set, and 'RUN' is called
                 * from the menu, then exit the menu, so that
                 * the routine is run, and then program will exit
                 */
                if ( menuflag ) {
                    menuflag=False;			/* turn off menu */
                    ag_clear(ag);
                } else {
                    /* RUN called from a file or the command line:
                     * There is no reason to be doing this.
                     */
                    opt_warning("No Run Function has been registered");
                }
                break;
				
            case QUITCH:
                opt_quit();
                break;
				
            case BANG:
                /* If there is a BANG as the first character of a
                 * menuline, then we shouldn't even get here.
                 */
                if (!menuflag)
                    opt_warning("Shell can only be invoked from the menu");
                else {
                    opt_warn_1("Shell to system invalid unless \'%c\' is the first character in the line\n",BANG);
                }
#if 0
                /* bang...shell to system */
                system(argnext(ag));
                break;
#endif

            case ' ':		/* blanks and empty characters, ignore */
            case '\t':
            case '\0':
                break;
				
            default:
                /* in the default case, option may be undelimited */
                /* ---------------------------------------------- */
                if(DEBUG) ag_fprint(stderr,ag);
                ag_backspace(ag);
                if(DEBUG) {
                    opt_mess_1("opt_proc: in default section [%s]\n",ag_s(ag));
                    ag_fprint(stderr,ag);
                }
                /* Try to process it as an undelimited option */
                if( opt_undelim(ag) == 0) {
                    /* if not successful...then stop processing */
                    ag_backword(ag);
                    if(DEBUG) ag_fprint(stderr,ag);
                    return ag;
                }
                break;
                /* last case */
            }
        }
    }
    return (ARGVECTOR *)NULL;
}/*opt_process*/

/* opt_lineprocess()
 * process a string, by converting it first into an argument vector
 * then calling opt_process
 * return the number of processed arguments
 */

int
opt_lineprocess(char *line)
{
    int nargc;
    char **nargv;

    if( line==NULL || *line=='\0') return(0);
 
    line2argv(&nargc,&nargv,line);
    opt_process(nargc,nargv);
    return(nargc);
}
/*	line2argv(): converts a one-line string into an argument vector */

static int
line2argv(int *pargc, char ***pargv, char *line)
{
    char	*lincp;
    if(line==NULL) {	
	*pargc = 0;
	**pargv = NULL;
	return(0);
    }
	/*
	 * First thing to do is copy the line into
	 * a buffer ("lincp") so that input line will
 	 * not be corrupted -- also so that input line
 	 * doesn't have to be double null terminated
 	 */
    lincp = (char *)calloc(strlen(line)+2,sizeof(char));
    strcpy(lincp,line);
	/*
	 * Next step is to double null terminate 
	 * the copied line
	 */
    lincp[strlen(line)+1]='\0';
    	/* count words in line */
    *pargc = l2a(lincp,NULL);
    	/* allocate array for arg vector */
    *pargv = (char **)malloc(((*pargc)+1)*sizeof(char *));
    	/* fill arg vector with words in line */
    l2a(lincp,*pargv);
	/*
	 * Note that lincp cannot be freed since
	 * that space is used by pargv
	 */
    return(*pargc);
}

#define	QUOTE	'\"'
#define	BKSLASH	'\\'

/* l2a */
/*	l2a() is slave routine to line2argv()           */
/*	if argv==NULL then count the words in the line	*/
/*	if argv!=NULL then put those words into argv[]  */
/* 	WARNINGS:
 *	l2a assumes that input line is double-null terminated!!
 *	the line buffer is pointed to by argv[]'s so do not
 *	free the input line buffer
 */
	/* quoted material counts as a single word */
	/* so that -s"string with spaces"-g is parsed */
	/* into 
		-s
	        string with spaces
		-g
	*/
	/* Comment: should be able to escape with backslash */

static int
l2a(char *line, char **argv)
{
    flag inquote=False;	/* flag: inside quotation */
    int	 iarg;
    
    for(iarg=0; *line != '\0'; ++iarg) {
        if(!inquote) {
            while( isspace(*line) )
                ++line;	/* skip leading blank spaces */
            if( *line == QUOTE ) {
                inquote=True;
                ++line;	/* skip past leading quote */
            }
        }
        if(argv!=NULL)			/* point to */
            argv[iarg] = line;	/* first character of line */
		
        while( !break_word(inquote,line) )
            ++line;
		
        if( *line==QUOTE ) {		/* toggle quote */ 
            inquote = (inquote==True ? False : True );
            if(argv==NULL)	++line;	/* skip past quote */
        }
		
        if(argv!=NULL) {
            *line='\0';	/* Null terminate string */
            ++line;		/* and go to next character */
        }
        else 
            while( isspace(*line) )
                ++line;		/* skip trailing blanks */
		
    }
    return(iarg);
}
static flag
break_word(flag inquote, char *line)
{
    if( *line == '\0' || *line==QUOTE )
        return(True);
    if( !inquote && isspace(*line) )
        return(True);
    
    return(False);
}


	/* --------------------------- */
	/* write out a usage statement */
	/* --------------------------- */

void
short_usage(void)
{
    if(opt_titlestring != NULL)
        opt_message(opt_titlestring);
    if(opt_usagestring != NULL)
        opt_mess_2("Usage: %s %s\n",opt_program_name,opt_usagestring);
    else
        opt_mess_1("Usage: %s [options]\n",opt_program_name);
    
    opt_mess_1("To invoke the menu, type:\n\t%s --menu\n",
               opt_program_name);
}	
void
long_usage(void)
{
    opt_message("The options are:\n");
    opt_usage();
}

	/* --------------------------------- */
	/* put current options in named file */
	/* --------------------------------- */

int
opt_tofname(char *fname)
{
    FILE	*fp;
    
    if( *fname != OPTTOFILE ) {
	free((char *)optfile_name);
	optfile_name = strdup(fname);
    }
    backup_file(optfile_name);
    fp = fopen(optfile_name,"w");

    if(fp==NULL) {
	opt_mess_1("cant open opt file [%s] for writing\n",fname);
	return 0;
    }
    opt_tofile(fp);
    fclose(fp);
    return 1;
}
static int
backup_file(char *fname)
{
    int c;
    FILE *fp,*fp_bak;
    char *fname_bak;
    
    fp = fopen(fname,"r");
    if (fp == NULL)
        return 1;               /* file fname doesn't exist */
    fname_bak = append_string(fname,"~");
    fp_bak = fopen(fname_bak,"w");
    if (fp_bak == NULL) {
        fclose(fp);
        return 1;               /* cant open backup file */
    }
    /* copy file */
    while ((c = getc(fp)) != EOF) {
        putc(c,fp_bak);
    }
    opt_mess_1("Options file [%s] has been overwritten\n",fname_bak);
    fclose(fp_bak);
    fclose(fp);
    return 0;                   /* success */                   
}

	/* ----------------------------------------- */
	/* get and process options from a named file */
	/* ----------------------------------------- */

#define	MAXOPLINE	256
int
opt_fromfname(char *fname)
{
    FILE	*fp;
    char	line[MAXOPLINE+2];	/* leave room for termination */
    flag        tmp_fileflag;
    
    if (ISEMPTYSTRING(fname)) {
        opt_warn_1("%cfile.opt fails to specify file.opt\n",OPTFROMFILE);
        return 0;
    }
    if (*fname == OPTFROMFILE) {      /* if '@@' */
        fp = fopen(optfile_name,"r");
    } else {                          /* if '@file.opt' */
        fp = fopen(fname,"r");
    }
    if (fp == NULL) {
        return 0;
    }

    tmp_fileflag = opt_fileflag;
    opt_fileflag = True;
    while( opt_getline(line,fp) > 0 )
    	opt_lineprocess(line);
    opt_fileflag = tmp_fileflag;
    
    fclose(fp);
    return 1;                   /* success */
}
int
opt_getline(char *line, FILE *fp)
{
    int	c;
    int	count=0;
	
    while( (c=getc(fp)) != '\n' && c!=EOF ) {
        *line = (char)c;
        ++line;
        if( ++count > MAXOPLINE-3 ) {
            opt_warning("Options line too long");
            break;
        }
    }
    *line++ = '\0';		/* double terminate line !! */
    *line++ = '\0';
    
    return(count);
}/*opt_getline*/

/* ------------------- */
/* basic help function */
/* ------------------- */

void
opt_help(char *s)
{
    if(s==NULL || *s=='\0') {
        opt_mess_2("\t%c %-20s\n",DELIM,"Options delimiter"); 
        opt_mess_2("\t%c %-20s\n",HELPCH,"Help");
        opt_mess_2("\t%c %-20s\n",RUN,"Run program and return to menu");
        opt_mess_2("\t%c %-20s\n",BANG,"Shell to Operating System"); 
        if (menuflag)
            opt_mess_2("\t%c %-20s\n",INTERACT,"Exit menu"); 
        else
            opt_mess_2("\t%c %-20s\n",INTERACT,"Invoke menu"); 
        opt_mess_2("\t%c %-20s\n",ADDITIONAL_OPTS,"Additional options");
        opt_mess_3("\t%c<filename> %-20s [%s]\n",OPTFROMFILE,
                   "Get options from file",optfile_name);
        opt_mess_4("\t%c%c %-2s [%s]\n",OPTFROMFILE,OPTFROMFILE,
                   "Get options from file",optfile_name);
        opt_mess_2("\t%c<filename> %-20s\n",OPTTOFILE,
                   "Put options in file");
        opt_mess_4("\t%c%c %-2s [%s]\n",OPTTOFILE,OPTTOFILE,
                   "Put options in file",optfile_name);
        opt_mess_2("\t%c %-20s\n",QUITCH,"Quit");
    } else {
        if( s[1]=='\0')
            opt_get_help(s[0]); 
        else {
            opt_mess_1("Help unavailable for: [%s]\n",s);
        }
    }
}
/* ------ */
/* quit() */ 
/* ------ */
void
opt_quit(void)
{
    int retval;

    if( opt_quit_fcn != NULL )
        retval = (*opt_quit_fcn)();
    /* Do we want to do anything with the retval? */
    /* eg, exit vs optAbortRun?? */
    exit(opt_exit_number);
}

/* OPT v3.7: options parsing tool */
/*
 * Copyright (C) 1998, James Theiler (jt@lanl.gov)
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 * 
 */
/* $Id: opt.c,v 1.1 1998/09/19 04:10:07 jt Exp $ */
/* ag.c */

#ifndef	SINGLEFILE
#include <stdio.h>
#include <stdlib.h>
#ifdef convex
#include <strings.h>
#else
#include <string.h>
#endif
#include "opt.h"                /* needed for __PROTO */
#include "ag.h"
#endif

/* primitive routines for manipulation argument vectors */

/*
  make-new-argvector              ag_new()
  reset-argvector                 ag_reset()
  flag-end-of-word                ag_eow()
  what-is-character               ag_c()
  what-is-string                  ag_s()

  read-character                  ag_c()
  read-next-character             ag_c_next()
  read-next-non-null-character    ag_cnn_next()
  read-character-advance          ag_c_advance()
  read-string                     ag_s()
  read-next-string                ag_s_next()
  read-string-advance             ag_s_advance()
  word-number                     ag_w_number()
  word-advance                    ag_w_advance()
  backspace                       ag_backspace()
  clear                           ag_clear()

  get-argc                        ag_argc()
  get-argv                        ag_argv()

  get-next-argument               argnext()
  get-next-argument-value         argnextnum()
*/

ARGVECTOR *
ag_new(int argc, char **argv)
{
    ARGVECTOR *ag;
    ag = (ARGVECTOR *)malloc(sizeof(ARGVECTOR));
    /* Note...we do not actually make a COPY of argv; but this
     * shouldn't be necessary, since *none* of the following routines
     * should ever write to ag->c and *especially* not ag->v
     */
    ag->v = argv;
    ag->c = argc;
    ag->iw = 0;
    ag->ic = 0;
    return(ag);
}
void
ag_free(ARGVECTOR *ag)
{
    free((char *)ag);
}
void
ag_fprint(FILE *fp, ARGVECTOR *ag)
{
        int i;
        if (ag == NULL) {
            fprintf(fp,"ag=<nul>\n");
            return;
        }
        for(i=0; i<ag->c; ++i)
            fprintf(fp,"[%s]",ag->v[i]);
        fprintf(fp,", <%d> <%d>\n",ag->iw,ag->ic);
}
void
ag_reset(ARGVECTOR *ag)
{
    ag->iw = 0;
    ag->ic = 0;
}
int
ag_w_number(ARGVECTOR *ag)
{
    return ag->iw;
}
void
ag_w_advance(ARGVECTOR *ag)
{
    ++(ag->iw);             /* advance to next word */
    ag->ic=0;               /* beginning of next word */
}
/*      ag_eow: end of word
        flag whether current position is at end of word
*/
int
ag_eow(ARGVECTOR *ag)
{
    if( ag->iw >= ag->c )
        return(TRUE);
    if( ag->ic >= strlen(ag->v[ag->iw]) )
        return(TRUE);
    return(FALSE);
}
/*      ag_end: end of command line
                flag whether current position is at end of command line 
*/
int
ag_end(ARGVECTOR *ag)
{
        if( ag->iw >= ag->c )
                return(TRUE);
        if( ag_eow(ag) && ag->iw == (ag->c)-1 )
                return(TRUE);
        return(FALSE);
}
/*      ag_c:   return current character
                do not advance
*/
char
ag_c(ARGVECTOR *ag)
{
        return(ag->v[ag->iw][ag->ic]);
}
char
ag_c_next(ARGVECTOR *ag)
{
        return(ag->v[ag->iw][ag->ic+1]);
}
char
ag_cnn_next(ARGVECTOR *ag)
{
    if( ag_c_next(ag) == '\0' ) {
        if(ag->iw+1 >= ag->c)
            return('\0');
        else
            return(ag->v[ag->iw+1][0]);
    }
    else
        return( ag_c_next(ag) );
}
/*      ag_c_advance:   read current character, and advance to next
                        return '\0' if end of word
                        do not advance to next word
*/
char
ag_c_advance(ARGVECTOR *ag)
{
        char    c;              /* current character */

        if( ag_eow(ag) )
                return(c='\0'); /* return NULL to signal that current*/
                                /* character is past end of word     */
        c = ag->v[ag->iw][ag->ic];
        ++(ag->ic);             /* advance to next character */
        return(c);
}
void
ag_backword(ARGVECTOR *ag)
{
    ag->iw -= 1;
}

char
ag_backspace(ARGVECTOR *ag)
{
        if( --(ag->ic) < 0 )            /* if back past beginning of word */
        {       ag->ic=0;
                if(--(ag->iw) < 0)      /* goto beginning of previous word */
                        ag_reset(ag);           /* if no previous, reset */
                else
                {       while( !ag_eow(ag) )    /* goto end of prevous word */
                                ag_c_advance(ag);
                        ag_backspace(ag);       /* back to just before end */
                }
        }
        return(ag->v[ag->iw][ag->ic]);
}
/*      ag_s:   returns current string
                returns "" if current position is at end of word
                returns NULL if past end of argument vector
*/
char    *
ag_s(ARGVECTOR *ag)
{
        if( ag->iw < ag->c )
                return( ag->v[ag->iw]+ag->ic );
        else    return( NULL );
}
char    *
ag_s_next(ARGVECTOR *ag)
{
        if( ag->v[ag->iw][ag->ic+1] == '\0' )
        {
                if(ag->iw+1 >= ag->c)
                        return(NULL);
                else    return(ag->v[ag->iw+1]);
        }
        else    return( ag->v[ag->iw]+ag->ic+1 );
}
/*      ag_s_advance:   read current string and advance to next
                        returns NULL if current string is at end
                        does not check advanced string
*/
char    *
ag_s_advance(ARGVECTOR *ag)
{
    char    *s;             /* current string */
    
    if( ag_eow(ag) )        /* if end of word, go to next word */
        ag_w_advance(ag);
    if( ag_eow(ag) )        /* if still at end of word,  */
        s = NULL;       /* signify by returning NULL */
    else
        s = ag->v[ag->iw] + ag->ic;
    
    ag_w_advance(ag);       /* advance to next word */
    
    return(s);
}
int
ag_clear(ARGVECTOR *ag)
{
    while( !ag_end(ag) )
        argnext(ag);
    return 1;
}

int
ag_argc(ARGVECTOR *ag)
{
    return ag->c - ag->iw;
}
char **
ag_argv(ARGVECTOR *ag)
{
    return ag->v + ag->iw;
}
ARGVECTOR *
ag_copy(ARGVECTOR *ag)
{
    /* Here is how you would make a copy of an ARGVECTOR */
    /* To free this, do not use ag_free, but ag_freeall */
    int i;
    ARGVECTOR *agnew;
    agnew = (ARGVECTOR *)malloc(sizeof(ARGVECTOR));
    agnew->c = ag->c;
    agnew->v = (char **)malloc(sizeof(char *));
    for (i=0; i< agnew->c; ++i) {
        agnew->v[i] = strdup(ag->v[i]);
    }
    agnew->iw = 0;
    agnew->ic = 0;
    return agnew;
}
void
ag_freeall(ARGVECTOR *ag)
{
    int i;
    for (i=0; i<ag->c; ++i) {
        free(ag->v[i]);
    }
    free((char *)ag->v);
    free((char *)ag);
}
ARGVECTOR *
ag_prepend_argv0(ARGVECTOR *ag, char *argv0)
{
    int i;
    ARGVECTOR *agnew;
    agnew = (ARGVECTOR *)malloc(sizeof(ARGVECTOR));
    agnew->c = ag->c - ag->iw + 1;
    agnew->v = (char **)malloc(agnew->c * sizeof(char *));
    agnew->v[0] = strdup(argv0);
    for (i=1; i< agnew->c; ++i) {
        agnew->v[i] = strdup(ag->v[i + ag->iw - 1]);
    }
    agnew->iw = 0;
    agnew->ic = 0;
    return agnew;
}

    


	/* ------------------------ */
	/* return the next argument */
	/* ------------------------ */
char *
argnext(ARGVECTOR *ag)
{
    static char nullchar='\0';
    char *s;

    s = ag_s_advance(ag);
    if( s==NULL )	
    	s = &nullchar;
    return(s);
}
	/* ------------------------------------------- */
	/* return the numerical value of next argument */
	/* ------------------------------------------- */
double	
argnextnum(ARGVECTOR *ag)
{
#if 0
    extern double atof(const char *);
#endif
    return( atof(argnext(ag)) );
}




