/* $Id: sqmatsolve.c,v 1.7 1995/04/03 05:51:31 jt Exp jt $ */

#include <stdio.h> /* for debugging */
#include <math.h>  /* for sqrt */
#include "nrutil.h"

extern int verbose;
extern int fit_report(float *w, float **v, int m);
extern int svd_solve(float **x, float *y, float *a,
		     int n, int m, float **u, float *w, float **v);


/* uses SVD to solve a square mxm matrix equation ax=b */
void
sqmatsolve(float **a,
	   float *b,
	   float *x,
	   int m)
{
    int j;
    float **u,**v,*w;
    u = matrix(1,m,1,m);
    v = matrix(1,m,1,m);
    w = vector(1,m);

    svd_solve(a,b,x,m,m,u,w,v);
    
    /* since these are normal equations, we want sqrt(w) instead of w */
    for (j=1; j<=m; ++j)
	w[j] = sqrt(w[j]);

    if (verbose)
	fit_report(w,v,m);

    free_matrix(u,1,m,1,m);
    free_matrix(v,1,m,1,m);
    free_vector(w,1,m);
}

	
		
			
