/* $Id: svd_matsolve.c,v 1.2 1995/04/03 05:52:10 jt Exp jt $ */

#include <stdio.h>
#include <math.h>
#include "nrutil.h"

extern int verbose;

extern int fit_report(float *w, float **v, int m);
extern int svd_solve(float **x, float *y, float *a,
		     int n, int m, float **u, float *w, float **v);

/* Uses SVD to solve Xa=y where X has n rows and m columns */
int
svd_matsolve(float **x, float *y, float *a, int n, int m)
{
    float **u,**v,*w;
    u = matrix(1,n,1,m);
    v = matrix(1,m,1,m);
    w = vector(1,m);

    svd_solve(x,y,a,n,m,u,w,v);

    if (verbose)
	fit_report(w,v,m);

    free_matrix(u,1,n,1,m);
    free_matrix(v,1,m,1,m);
    free_vector(w,1,m);
}





