package MeanVar;


    
sub new { 
    my $class = shift;
    $class = ref($class) || $class; # see Camel Book, p295
    my $self = {};                  # All Std Objects are hashes
    bless $self,$class;
    $self->init(@_);
    return $self;
}
sub init {
    my $self = shift;
    my $name = shift || "";
    $self->{name}  = $name;
    $self->{sum}   = 0;
    $self->{sumsq} = 0;
    $self->{count} = 0;
}
sub addData {
    my $self = shift;
    my $data = shift || 0;
    $self->{sum}   += $data;
    $self->{sumsq} += $data*$data;
    $self->{count} += 1;
    return $self;
}
sub print {
    my $self = shift;
    print STDERR 
	$self->{name},
	", sum=",$self->{sum},
	", ssq=",$self->{sumsq},
	", cnt=",$self->{count},
	"\n";
}
sub mean {
    my $self = shift;
    return ($self->{sum}/$self->{count});
}
sub variance {
    my $self = shift;
    my $var = $self->{sumsq};
    my $sum = $self->{sum};
    my $cnt = $self->{count};

    $var -= $sum*$sum/$cnt;
    $var /= $cnt;
}
sub stddev {
    my $self = shift;
    my $var = $self->variance;
    if ($var<0) {
	$self->print;
	warn "Negative variance: $var";
	return -sqrt(-$var);
    }
    return sqrt($var);
}
1;
__END__

@Usage = <<EU;
Computes the mean and variance of data as it arrives.
Data is added one at a time using 'addData' method; 
then mean and variance are provided when asked, using
'mean' and 'variance' methods.
EU



