#!/packages/bin/perl -ws
## Take two files (call them A and B), and each file contains a list
## of numbers.  Produce on output a much longer list equal to the sums
## of all the pairs.

($me=$0) =~ s,.*/,,;

$addConst ||= 0;		# add a constant to all the sums

$fileA = shift @ARGV || &usage;
$fileB = shift @ARGV || &usage;

open(A,"$fileA") || die "Cant open file [$fileA]";
open(B,"$fileB") || die "Cant open file [$fileB]";

@listA = ();
@listB = ();

while(<A>) {
    chomp;
    push @listA,$_;
}
close A;
while(<B>) {
    chomp;
    push @listB,$_;
}
close B;

foreach $valA (@listA) {
    foreach $valB (@listB) {
	print $addConst + $valA + $valB, "\n";
    }
}

sub usage {
    print <<EndUsage;
Usage: $me [-addConst=\#] fileA fileB
       Reads all the numeric values in fileA and fileB and 
       Writes to stdout the pairwise sums of all those values.
       You can add a constant to these sums using the command line flag.
EndUsage
    exit;
}

__END__
