#!/usr/bin/perl -s
##

$a ||= 6.8351;  $ra=3.0;
$b ||= 422.21;  $rb=25.0;
$t ||= 3.6923;  $rt=2.5;
$nboot  ||= 50;
$over   ||= 1;
$save   ||= 0;
$efron  ||= 0;
$linfit ||= 0;

$runMaxLike="run-max-like";

sub boot_init {
    my $infile = shift;
    if ($efron) {
	open(INFILE,"$infile") || die;
	while (<INFILE>) {
	    push @infileLine,$_;
	}
	close INFILE;
	$N = scalar(@infileLine);
	print STDERR "N=$N\n";
    } 
    else {
	$mc = "mc -O$over -a$a -b$b -t$t -z -I $infile";
    }
}
sub boot {
    my $infile = shift;
    if ($efron) {
	open(INFILE,">$infile") || die;
	foreach $i (1 .. $N*$over) {
	    print INFILE $infileLine[int(rand($N))];
	}
	close INFILE;
    }
    else {
	system("$mc -s$ib > $infile");
    }
}

$infile = shift @ARGV || die;
&boot_init($infile);

for ($ib=1; $ib <= $nboot; ++$ib) {
    $infile = "tmp-boot-$$-$ib.in";
    &boot($infile);
    if ($linfit) {
	## linear fit 
	open(LIN,"linfit -m1 -Y1 -X0 -oa $infile |");
	chomp ($b = <LIN>);
	chomp ($a = <LIN>);
	close LIN;
	print STDERR "boot= $ib it= 0 a= $a b= $b tau= $t like= 0\n";
    } else {
	system("$runMaxLike -a=$a -b=$b -t=$t $infile");
    }
    unlink $infile unless $save;
}

__END__




