#!/usr/bin/perl -s
## Mean and std dev from the .err file produced by the bootstrap routines

$xy ||= 0;


use MeanVar;
use ConfidenceInterval;

$amv = new ConfidenceInterval("A");
$bmv = new ConfidenceInterval("B");
$tmv = new ConfidenceInterval("T");
$lmv = new ConfidenceInterval("L");
$omv = new ConfidenceInterval("O");

$count=1;
while(<>) {
    s/run-max-like/boot= $count/;
    next unless /^boot/;

    ($a,$b,$t,$like) = (split)[(5,7,9,11)];
    
    $amv->addData($a);
    $bmv->addData($b);
    $tmv->addData($t);
    $lmv->addData($like);
    $omv->addData(1990-$b/$a);
}
print STDERR "A: ",$amv->mean," +/- ",$amv->stddev," <",$amv->median,">","\n";
print STDERR "B: ",$bmv->mean," +/- ",$bmv->stddev," <",$bmv->median,">","\n";
print STDERR "T: ",$tmv->mean," +/- ",$tmv->stddev," <",$tmv->median,">","\n";
print STDERR "L: ",$lmv->mean," +/- ",$lmv->stddev," <",$lmv->median,">","\n";
print STDERR "O: ",$omv->mean," +/- ",$omv->stddev," <",$omv->median,">","\n";

print STDERR "A: [",join(",",$amv->interval(0.95)),"]\n";
print STDERR "O: [",join(",",$omv->interval(0.95)),"]\n";

if ($xy) {
    ($ohi,$olo) = $omv->interval(0.95);
    print "#lw 2\n";
    print "$olo 0\n$ohi 0\n#k\n";
    print "#lw .5\n";
    print "$olo 0\n$olo 0.005\n#k\n";
    print "$ohi 0\n$ohi 0.005\n#k\n";
}

__END__
