#include <math.h>
#define PI 3.141592654
extern double rand_unif(void);
#define float double
float gammln(float xx);

float poidev(float xm)
{
    static float sq,alxm,g,oldm=(-1.0);
    float em,t,y;

    if (xm < 12.0) {
        if (xm != oldm) {
            oldm=xm;
            g=exp(-xm);
        }
        em = -1;
        t=1.0;
        do {
            ++em;
            t *= rand_unif();
        } while (t > g);
    } else {
        if (xm != oldm) {
            oldm=xm;
            sq=sqrt(2.0*xm);
            alxm=log(xm);
            g=xm*alxm-gammln(xm+1.0);
        }
        do {
            do {
                y=tan(PI*rand_unif());
                em=sq*y+xm;
            } while (em < 0.0);
            em=floor(em);
            t=0.9*(1.0+y*y)*exp(em*alxm-gammln(em+1.0)-g);
        } while (rand_unif() > t);
    }
    return em;
}
#undef PI
/* (C) Copr. 1986-92 Numerical Recipes Software . */



