#include <stdio.h>
#include <math.h>
double qromb_eps=1.0e-5;

#define EPS qromb_eps
#define JMAX 20
#define JMAXP (JMAX+1)
#define K 5

double qromb(double (*func)(double), double a, double b)
{
    void polint(double xa[], double ya[], int n, double x, double *y, double *dy);
    double trapzd(double (*func)(double), double a, double b, int n);
    void nrerror(char error_text[]);
    double ss,dss;
    double s[JMAXP+1],h[JMAXP+1];
    int j;

    h[1]=1.0;
    for (j=1;j<=JMAX;j++) {
        s[j]=trapzd(func,a,b,j);
        if (j >= K) {
            polint(&h[j-K],&s[j-K],K,0.0,&ss,&dss);
            if (fabs(dss) < EPS*fabs(ss) || ss==0) return ss;
        }
        s[j+1]=s[j];
        h[j+1]=0.25*h[j];
    }
    fprintf(stderr,"Too many steps in routine qromb ss=%g\n",ss);
    return ss;
}

#undef EPS
#undef JMAX
#undef JMAXP
#undef K
/* (C) Copr. 1986-92 Numerical Recipes Software . */
