/* linmin.c */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "like.h"
#include "linmin.h"

static double parm_a,parm_b,parm_tau;
static double parm_aa, parm_bb, parm_tt,parm_to;
static int    parm_nn;
static double parm[3];
static double parmVector[3];
static int Npoints=0;
static Data_t *data=NULL;
static int count=0;

/* fcn_init: Sets the global variables in this file */
void
fcn_init_data(int N, Data_t *d)
{     
    Npoints=N;
    data = d;
}
void
fcn_init_parm(double a, double b, double tau, double va, double vb, double vtau)
{

    parm[0]=parm_a=a;
    parm[1]=parm_b=b;
    parm[2]=parm_tau=tau;
    parmVector[0]=va;
    parmVector[1]=vb;
    parmVector[2]=vtau;
}
void
flike_init(double a, double b, double tau, double to, int n)
{
    parm_aa=a;
    parm_bb=b;
    parm_tt=tau;
    parm_to=to;
    parm_nn=n;
}
double
flike(double t)
{
    double mu,like;
    mu = parm_aa*t+parm_bb;
    like=pois_like(mu,parm_nn)*time_like(parm_to-t,parm_tt);
    return like; 
}
    
int reset_count(void)
{
    int c;
    c = count;
    count = 0;
    return c;
}
        
double fcn3d(double *p)
{
    /* -1x, so that we seek minimum 'stead of max */
    ++count;
    return -1.0*full_loglike_array(p[0],p[1],p[2],Npoints,data);
}
double fcn1d(double x)
{
    double p[3];
    int i;
    for (i=0; i<3; ++i) {
        p[i] = parm[i] + x*parmVector[i];
    }
    return fcn3d(p);
}
    












