/* rand.c */

/* GSL rng prototypes for gfsr4 */
extern void *gfsr4_new (unsigned long s);
extern unsigned long gfsr4_get (void *vstate);
extern double gfsr4_get_double (void *vstate);
extern void gfsr4_set (void *state, unsigned long s);

/* static state: this code is not thread-safe! */
static void *state=(void *)0;

/* interface functions: init, unif, seed, ulong */
// ++pac inline 
static void init()
{
    state = gfsr4_new(0);
}
// ++pac inline 
 double rand_unif()
{
    if (!state) init();
    return gfsr4_get_double(state);
}
// ++pac inline 
 unsigned long rand_ulong()
{
    if (!state) init();
    return gfsr4_get(state);
}
// ++pac inline 
 void rand_seed(int s)
{
    if (!state) init();
    gfsr4_set(state,(unsigned long)s);
}

